﻿#include <iostream>
#include <vector>
#include <set>
#include<map>
#include<deque>
#include <algorithm>
#include <string>

using namespace std;

typedef long long ll;

template<typename T> istream& operator>>(istream& in, vector<T>& a) { for (int i = 0; i < a.size(); ++i) in >> a[i]; return in; }
template<typename T> ostream& operator<<(ostream& out, vector<T>& a) { for (int i = 0; i < a.size(); ++i) out << a[i] << ' '; return out; }

template<typename T1, typename T2> istream& operator>>(istream& in, pair<T1, T2>& p) { in >> p.first >> p.second; return in; }
template<typename T1, typename T2> ostream& operator<<(ostream& out, pair<T1, T2>& p) { out << p.first << ' ' << p.second; return out; }



#define all(x) x.begin(),x.end()
#define range(i,n) for (int i=0;i<n;++i)
#define rrange(i,n) for (int i=n-1;i>=0;--i)


int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.setf(ios::fixed);
    cout.precision(15);

    int n;
    cin >> n;
    vector<int> arr(n);
    cin >> arr;
    vector<int> a(n), b(n), c(n), d(n);
    vector<ll> suf_sum(n);
    range(i, n) {
        if (i == 0) {
            a[i] = b[i] = arr[i];
        }
        else {
            a[i] = max(arr[i], a[i - 1]);
            b[i] = min(arr[i], b[i - 1]);
        }
    }
    rrange(i, n) {
        if (i == n - 1) {
            c[i] = d[i] = arr[i];
            suf_sum[i] = arr[i];
        }
        else {
            c[i] = max(arr[i], c[i + 1]);
            d[i] = min(arr[i], d[i + 1]);
            suf_sum[i] = arr[i] + suf_sum[i + 1];
        }
    }
    //cout << suf_sum << '\n';
    vector<double> ans(n);
    ans[0] = 1;
    auto f = [&](double t, int i) {
        return max(1.0 * a[i - 1], (1.0 - t) * c[i]) -
            min(1.0 * b[i - 1], (1.0 - t) * d[i]);
    };
    for (int i = 1; i < n; ++i) {
        vector<double> x;
       x.push_back(1.0);
       x.push_back(0.0);

        x.push_back(1 - 1.0 * a[i - 1] / d[i]);
        if (x.back() < 0 || x.back() > 1) x.pop_back();
        
        x.push_back(1 - 1.0 * a[i - 1] / c[i]);
        if (x.back() < 0 || x.back() > 1) x.pop_back();

        x.push_back(1 - 1.0 * d[i]/ a[i - 1]);
        if (x.back() < 0 || x.back() > 1) x.pop_back();

        x.push_back(1 - 1.0 * c[i]/ a[i - 1]);
        if (x.back() < 0 || x.back() > 1) x.pop_back();

        x.push_back(1 - 1.0 * b[i - 1] / c[i]);
        if (x.back() < 0 || x.back() > 1) x.pop_back();

        x.push_back(1 - 1.0 * b[i - 1] / d[i]);
        if (x.back() < 0 || x.back() > 1) x.pop_back();

        x.push_back(1 - 1.0 *  c[i]/ b[i - 1]);
        if (x.back() < 0 || x.back() > 1) x.pop_back();

        x.push_back(1 - 1.0 *  d[i]/ b[i - 1]);
        if (x.back() < 0 || x.back() > 1) x.pop_back();

        // cout << x << '\n';
        vector<pair<pair<double, long double>, double>> y;
        for (auto t : x) {
            y.push_back({ { f(t,i), -1.0l * t * suf_sum[i]},t });
        }
        //cout << "! " << y << '\n';
        ans[i] = (*min_element(all(y))).second;
    }
    cout << ans;
}