#include <iostream>
#include <vector>

using namespace std;
struct point{
    int min;
    int max;
    int left;
    int right;
    point(int min = 0, int max = 0, int left = 0, int right = 0)
    {
        this->min = min;
        this->max = max;
        this->left = left;
        this->right = right;
    }
};

struct tree{
    vector<int> el;
    vector<point> bin;

    tree(vector<int> v)
    { 
        el = v;
        bin.resize(el.size()*4);
        init(0, 0, el.size()-1);
    }   

    void init(int n, int l, int r)
    {
        //cout << l << " " << r << "/n";
        if(l == r) bin[n] = point(el[l], el[l], l, r);
        else
        {
            int mid = (l+r)/2;
            init(2*n+1, l, mid);
            init(2*n+2, mid+1, r);
            int mn = min(min(el[mid], bin[2*n+1].min), bin[2*n+2].min);
            int mx = max(max(el[mid], bin[2*n+1].max), bin[2*n+2].max);
            bin[n] = point(mn, mx, l, r);
        }
        return;
    }

    int minimum(int l, int r)
    {
        return getmin(0, l, r);
    }

    int maximum(int l, int r)
    {
        return getmax(0, l, r);
    }

    private: 
        int getmin(int n, int l, int r)
        {
            //cout << l << r << " " << bin[n].left << bin[n].right << "\n";
            int mid = (bin[n].left+bin[n].right)/2;
            if(bin[n].left == l && bin[n].right == r) return bin[n].min;
            else
            {
                if(l <= mid && r > mid)
                {
                    return min(getmin(2*n+1, l, mid), getmin(2*n+2, mid+1, r));
                }
                else if(l <= mid) return getmin(2*n+1, l, r);
                else return getmin(2*n+2, l, r);
            }
        }

        int getmax(int n, int l, int r)
        {
            //cout << l << r << " " << bin[n].left << bin[n].right << "\n";
            int mid = (bin[n].left+bin[n].right)/2;
            if(bin[n].left == l && bin[n].right == r) return bin[n].max;
            else
            {
                if(l <= mid && r > mid)
                {
                    return max(getmax(2*n+1, l, mid), getmax(2*n+2, mid+1, r));
                }
                else if(l <= mid) return getmax(2*n+1, l, r);
                else return getmax(2*n+2, l, r);
            }
        }
};

int main()
{
    #if 0
    vector<int> v = {2,4,1,5,1,2,4,6};
    tree t(v);
    for(int i = 0; i < v.size(); i++)
    {
        for(int j = i; j < v.size(); j++)
        {
            cout << t.minimum(i,j) << "-" << t.maximum(i,j) << "\n";
        }
    }
    #endif 

    int n;
    cin >> n;
    vector<int> v;
    for(int i = 0; i < n; i++)
    {
        int k;
        cin >> k;
        v.push_back(k);
    }    

    tree t(v);
    int last = v.size()-1;
    cout << 1.00 << " ";
    for(int i = 0; i < n-1; i++)
    {
        int minl = t.minimum(0, i);
        int maxl = t.maximum(0, i);

        
        int minr = t.minimum(i+1, last);
        int maxr = t.maximum(i+1, last);

        double k = (double)(maxr - maxl)/maxr;
        k = max(0.,k);

        if(minl <= (1-k)*minr)
        {
            k = (double)(minr - minl)/minr;
        }
        
        cout << k << " ";
    }
}