﻿#include <iostream>
#include <string>
#include <algorithm>
#include <stack>
#include <map>
#include <set>
#include <cstdio>
#include <vector>
#include <cmath>
#include <queue>
#include <numeric>
#include <climits>
#include <random>
#include <fstream>
#include <cstdlib>
#include <bitset>
#include <deque>
#include <iterator>

using namespace std;

template <typename T> inline T getint() {
	T val = 0;
	char c;
	bool neg = false;
	while ((c = getchar()) && !(c >= '0' && c <= '9')) {
		neg |= c == '-';
	}
	do {
		val = (val * 10) + c - '0';
	} while ((c = getchar()) && (c >= '0' && c <= '9'));
	return val * (neg ? -1 : 1);
}

#define int long long
#define x first
#define y second
typedef long long ll;
typedef long double ld;
const ll INF = LLONG_MAX;

ll gcd(ll a, ll b) {
	return b ? gcd(b, a % b) : a;
}

const ll maxn = 1e5;
const ld eps = 1e-10;

ll s;
vector <ll> a;
vector <ll> b;

bool pr(ll m, ll n) {
	ll ost = 0;
	vector <ll> b_t(n);
	for (ll i = 0; i < n; ++i)
		b_t[i] = b[i];
	vector <ll> a_t(n);
	for (ll i = 0; i < n; ++i)
		a_t[i] = a[i];
	ll ind_b = 0;
	ll st = 0;
	for (ll i = 0; i < n; ++i) {
		if (ind_b < n && b_t[ind_b] == 0 || abs(i - ind_b) > m)
			++ind_b;
		if (ind_b < n && b_t[ind_b] - a_t[i] >= 0 && abs(i - ind_b) <= m) {
			st += a_t[i];
			b_t[ind_b] -= a_t[i];
			a_t[i] = 0;
			continue;
		}
		while (ind_b < n && b_t[ind_b] - a_t[i] <= 0 && abs(i - ind_b) <= m) {
			st += b_t[ind_b];
			a_t[i] -= b_t[ind_b];
			b_t[ind_b] = 0;
			++ind_b;
		}
		if (ind_b < n && b_t[ind_b] - a_t[i] >= 0 && abs(i - ind_b) <= m) {
			st += a_t[i];
			b_t[ind_b] -= a_t[i];
			a_t[i] = 0;
			continue;
		}
	}
	if (st == s)
		return true;
	else
		return false;
}

signed main() {
	std::ios::sync_with_stdio(false);
	std::ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll n; cin >> n;
	a.resize(n);
	s = 0;
	for (ll i = 0; i < n; ++i) {
		cin >> a[i];
		s += a[i];
	}
	b.resize(n);
	ll s2 = 0;
	for (ll i = 0; i < n; ++i) {
		cin >> b[i];
		s2 += b[i];
	}
	if (s > s2) {
		cout << -1;
		return 0;
	}
	ll l = 0;
	ll r = n;
	while (l + 1 < r) {
		ll m = (l + r) / 2;
		if (pr(m, n))
			r = m;
		else
			l = m + 1;
	}
	for (ll i = l; i <= n; ++i) {
		if (pr(i, n)) {
			cout << i;
			return 0;
		}
	}
	cout << -1;
}