﻿#include <iostream>
#include <string>
#include <algorithm>
#include <stack>
#include <map>
#include <set>
#include <cstdio>
#include <vector>
#include <cmath>
#include <queue>
#include <numeric>
#include <climits>
#include <random>
#include <fstream>
#include <cstdlib>
#include <bitset>
#include <deque>
#include <iterator>

using namespace std;

template <typename T> inline T getint() {
	T val = 0;
	char c;
	bool neg = false;
	while ((c = getchar()) && !(c >= '0' && c <= '9')) {
		neg |= c == '-';
	}
	do {
		val = (val * 10) + c - '0';
	} while ((c = getchar()) && (c >= '0' && c <= '9'));
	return val * (neg ? -1 : 1);
}

#define int long long
#define x first
#define y second
typedef long long ll;
typedef long double ld;
const ll INF = LLONG_MAX;
ll mod = 1666666667;

ll gcd(ll a, ll b) {
	return b ? gcd(b, a % b) : a;
}

const ll maxn = 1e5;
const ld eps = 1e-8;
vector<pair<ld, int>> t;
ld ans = 0;
vector<int> perm = { -1,-1,-1,-1 };
vector<pair<ld, int>> q;

void check() {
	ld a1, a2, a3, a4;

	a1 = q[perm[0]].x;
	a2 = q[perm[1]].x;
	a3 = q[perm[2]].x;
	a4 = q[perm[3]].x;
	if (a1 == 0)
	{
		a2 = 0;
		ld ans_loc = (a1+1) * (a4+1) + (a3+1) + (a2+1);
		if (ans_loc > ans) {
			t[0].x = a1;
			t[1].x = a2;
			t[2].x = a3;
			t[3].x = a4;
			t[0].y = q[perm[0]].y;
			t[1].y = q[perm[1]].y;
			t[2].y = q[perm[2]].y;
			t[3].y = q[perm[3]].y;
			ans = ans_loc;
		}
		a2 = q[perm[1]].x;
		a3 = 0;
		ans_loc = (a1 + 1) * (a4 + 1) + (a3 + 1) + (a2 + 1);
		if (ans_loc > ans) {
			t[0].x = a1;
			t[1].x = a2;
			t[2].x = a3;
			t[3].x = a4;
			t[0].y = q[perm[0]].y;
			t[1].y = q[perm[1]].y;
			t[2].y = q[perm[2]].y;
			t[3].y = q[perm[3]].y;
			ans = ans_loc;
		}

	}
	else
		if (a1 * a4 < a2 * a3)
		{
			a2 = a1 * a4 / a3;
			ld ans_loc = (a1 + 1) * (a4 + 1) + (a3 + 1) + (a2 + 1);
			if (ans_loc > ans) {
				t[0].x = a1;
				t[1].x = a2;
				t[2].x = a3;
				t[3].x = a4;
				t[0].y = q[perm[0]].y;
				t[1].y = q[perm[1]].y;
				t[2].y = q[perm[2]].y;
				t[3].y = q[perm[3]].y;
				ans = ans_loc;
			}
		}
		else {
			a1 = a2 * a3 / a4;
			ld ans_loc = (a1 + 1) * (a4 + 1) + (a3 + 1) + (a2 + 1);
			if (ans_loc > ans) {
				t[0].x = a1;
				t[1].x = a2;
				t[2].x = a3;
				t[3].x = a4;
				t[0].y = q[perm[0]].y;
				t[1].y = q[perm[1]].y;
				t[2].y = q[perm[2]].y;
				t[3].y = q[perm[3]].y;
				ans = ans_loc;
			}
		}
}

void dfs(int pos) {
	if (pos == 4)
	{
		check();
		return;
	}
	for (int i = 0; i < 4; i++)
	{
		bool flag = 1;
		for (int j = 0; j < pos; j++)
			if (perm[j] == i)
				flag = 0;
		if(flag)
		{
			perm[pos] = i;
			dfs(pos + 1);
		}
	}
}

signed main() {
	std::ios::sync_with_stdio(false);
	std::ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cout.setf(ios::fixed);
	cout.precision(12);
	ld a1, a2, a3, a4;
	cin >> a1 >> a2 >> a3 >> a4;
	/*if ((a1 - 1) < eps || (a2 - 1) < eps || (a3 - 1) < eps || (a4 - 1) < eps)
	{
		cout << "1 2 3 4\n1.0 1.0 1.0 1.0\n";
		return 0;
	}*/
	q.resize(4);
	t.resize(4);
	q[0].x = a1-1;
	q[1].x = a2-1;
	q[2].x = a3-1;
	q[3].x = a4-1;
	q[0].y = 1;
	q[1].y = 2;
	q[2].y = 3;
	q[3].y = 4;

	dfs(0);	
	for (int i = 0; i < 4; i++)
		cout << t[i].y << " ";
	cout << "\n";
	for (int i = 0; i < 4; i++)
		cout << t[i].x +1 << " ";

}