﻿#include <iostream>
#include <string>
#include <algorithm>
#include <stack>
#include <map>
#include <set>
#include <cstdio>
#include <vector>
#include <cmath>
#include <queue>
#include <numeric>
#include <climits>
#include <random>
#include <fstream>
#include <cstdlib>
#include <bitset>
#include <deque>
#include <iterator>

using namespace std;

template <typename T> inline T getint() {
	T val = 0;
	char c;
	bool neg = false;
	while ((c = getchar()) && !(c >= '0' && c <= '9')) {
		neg |= c == '-';
	}
	do {
		val = (val * 10) + c - '0';
	} while ((c = getchar()) && (c >= '0' && c <= '9'));
	return val * (neg ? -1 : 1);
}

#define int long long
#define x first
#define y second
typedef long long ll;
typedef long double ld;
const ll INF = LLONG_MAX;
ll mod = 1666666667;

ll gcd(ll a, ll b) {
	return b ? gcd(b, a % b) : a;
}

const ll maxn = 1e5;
const ld eps = 1e-8;

struct point {
	ld x, y;
};

point roots(ld a1, ld b1, ld c1, ld a2, ld b2, ld c2) {
	ld a = a1 - a2;
	ld b = b1 - b2;
	ld c = c1 - c2;
	ld sDd2a = sqrt(b * b - 4.0 * a * c) / 2 / a;
	if (a > 0)
		return { -b / 2 / a - sDd2a, -b / 2 / a + sDd2a };
	else
		return { -b / 2 / a + sDd2a, -b / 2 / a - sDd2a };
}

point roots_d(ld a1, ld b1, ld c1, ld a2, ld b2, ld c2) {
	ld a = a1 - a2;
	ld b = b1 - b2;
	ld c = c1 - c2;
	ld sDd2a = sqrt(b * b - 4 * a * c) / 2 / a;
	if (a > 0)
		return { -b / 2 / a - sDd2a, -b / 2 / a + sDd2a };
	else
		return { -b / 2 / a + sDd2a, -b / 2 / a - sDd2a };
}

signed main() {
	std::ios::sync_with_stdio(false);
	std::ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cout.setf(ios::fixed);
	cout.precision(12);
	ll n; cin >> n;
	vector <ll> a(n), b(n), c(n);
	for (ll i = 0; i < n; ++i)
		cin >> a[i] >> b[i] >> c[i];
	ll pol = 0;
	ll otr = 0;
	for (ll i = 0; i < n; ++i) {
		if (a[i] > 0)
			pol = i;
		else
			otr = i;
	}
	point p1;
	p1.x = -b[pol] / (2 * a[pol]);
	p1.y = a[otr] * p1.x * p1.x + b[pol] * p1.x + c[pol];

	point p2;
	p2.x = -b[otr] / (2 * a[otr]);
	p2.y = a[otr] * p1.x * p1.x + b[otr] * p1.x + c[otr];

	//point p3 = roots(a[pol], b[pol], c[pol], a[otr], b[otr], c[otr]);

	//point p4 = roots_d(a[pol], b[pol], c[pol], a[otr], b[otr], c[otr]);


	cout << (p1.x + p2.x) / 2 << " " << (p1.y + p2.y) / 2;
}