﻿#include <iostream>
#include <string>
#include <algorithm>
#include <stack>
#include <map>
#include <set>
#include <cstdio>
#include <vector>
#include <cmath>
#include <queue>
#include <numeric>
#include <climits>
#include <random>
#include <fstream>
#include <cstdlib>
#include <bitset>
#include <deque>
#include <iterator>

using namespace std;

template <typename T> inline T getint() {
	T val = 0;
	char c;
	bool neg = false;
	while ((c = getchar()) && !(c >= '0' && c <= '9')) {
		neg |= c == '-';
	}
	do {
		val = (val * 10) + c - '0';
	} while ((c = getchar()) && (c >= '0' && c <= '9'));
	return val * (neg ? -1 : 1);
}

#define int long long
#define x first
#define y second
typedef long long ll;
typedef long double ld;
const ll INF = LLONG_MAX;
ll mod = 1666666667;

ll gcd(ll a, ll b) {
	return b ? gcd(b, a % b) : a;
}

const ll maxn = 1e5;
const ld eps = 1e-10;

ll hash_f(string s, char c) {
	ll ans = 0;
	ll r = s.size()+1;
	for(int i = 0;i<s.size();i++)
		if (s[i] == c) {
			r *= s.size() + 1;
			r %= mod;
			ans += r * (i + 1)%mod;
			ans %= mod;
		}
	return ans;

}

bool func(set <string> st, vector <char> used) {
	for (char c = 'a'; c <= 'z'; ++c) {
		if (used[c - 'a'])
			continue;
		bool flag = true;
		for (auto s : st) {
			bool flag_c_s = false;
			for (auto c_s: s)
				if (c_s == c) {
					flag_c_s = true;
					break;
				}
			if (!flag_c_s) {
				flag = false;
				break;
			}
		}
		if (!flag)
			continue;
		used[c - 'a'] = 1;
		map <ll, set <string>> mp;
		for (auto s : st) {
			ll t = hash_f(s, c);
			mp[t].insert(s);
		}
		bool flag_ans = true;
		for (auto to : mp) {
			if (to.second.size() != 1) {
				bool res = func(to.second, used);
				if (!res) {
					flag_ans = false;
					break;
				}
			}
		}
		if (flag_ans)
			return true;
		else
			return false;
	}
	return false;
}


signed main() {
	std::ios::sync_with_stdio(false);
	std::ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll l, n;
	cin >> l >> n;
	set <string> st;
	for (ll i = 0; i < n; ++i) {
		string s;
		cin >> s;
		st.insert(s);
	}
	vector <char> used(26);
	if (func(st, used))
		cout << "YES";
	else
		cout << "NO";
}