#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>
#include <numeric>
#include <map>

using namespace std;

#define all(s) (s).begin(), (s).end()

void solve() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int l, n;
    cin >> l >> n;
    vector<string> v(n);
    for (auto& str : v) cin >> str;
    vector<string> s(n);
    for (int i = 0; i < n; ++i) {
        s[i] = v[i];
        sort(all(s[i]));
        s[i].erase(unique(all(s[i])), s[i].end());
    }
    vector<int> ind(n);
    iota(ind.begin(), ind.end(), 0);
    vector<bool> used(26);
    auto solve = [&](auto solve, const vector<int>& ind) -> void {
        if (ind.size() == 1) return;
        vector<int> cnt(26);
        for (int i : ind) {
            for (char c : s[i]) cnt[c - 'a']++;
        }
        char c = 0;
        for (char x = 'a'; x <= 'z'; ++x) {
            if (cnt[x - 'a'] == ind.size() && !used[x - 'a']) c = x;
        }
        if (c == 0) {
            cout << "NO\n";
            exit(0);
        }
        used[c - 'a'] = true;
        map<vector<int>, vector<int>> divide;
        for (int i : ind) {
            vector<int> cind;
            for (int j = 0; j < l; ++j) if (v[i][j] == c) cind.push_back(j);
            divide[cind].push_back(i);
        }
        for (auto& entry : divide) {
            solve(solve, entry.second);
        }
        used[c - 'a'] = false;
    };
    solve(solve, ind);
    cout << "YES\n";
}

signed main() {
    solve();
}