#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define pb push_back
#define eb emplace_back
#define f first
#define s second
#define deb(a) cerr << fixed << setprecision(20) << #a << " = " << a << '\n';
//#define int long long

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;

typedef tree<
    pii,
    null_type,
    less<pii>,
    rb_tree_tag,
    tree_order_statistics_node_update>
ordered_set;

const int inf = 2e9;
const ll INF = 2e18;
const int MOD1 = 1e9 + 7;
const int MOD2 = 998244353;
const int P1 = 31;
const int P2 = 37;
const int dx[4] = {0, 0, -1, 1};
const int dy[4] = {-1, 1, 0, 0};
const ld Pi = acosl(-1);
const ld EPS = 1e-11;
const int N = 2e6;
int qqq = 1;

struct item{
    int mn, mx;

    item(){
        mn = inf;
        mx = -inf;
    }

    item(int _x){
        mn = mx = _x;
    }

    item(int _mn, int _mx){
        mx = _mx;
        mn = _mn;
    }
};

struct sparse{
    int n;
    vector <vector <item>> sp;
    vector <int> lg;

    sparse(vector <int> &a){
        n = a.size();
        lg.resize(n + 100, -1);
        sp.resize(24, vector <item> (n + 100));
        build(a);
    }

    inline item comb(item a, item b){
        item ans;
        ans.mn = min(a.mn, b.mn);
        ans.mx = max(a.mx, b.mx);
        return ans;
    }

    inline void build(vector <int> &a){
        for (int i = 0; i < a.size(); i++){
            sp[0][i] = item(a[i]);
        }

        for (int i = 0; (1 << i) < n; i++){
            lg[(1 << i)] = i;
        }

        {
            int cur = 0;
            for (int i = 1; i < lg.size(); i++){
                if (lg[i] != -1)
                    cur = lg[i];
                else
                    lg[i] = cur;
            }
        }

        for (int log = 1; (1 << log) - 1 < n; log++){
            for (int i = 0; i + (1 << log) - 1 < n; i++){
                sp[log][i] = comb(sp[log - 1][i], sp[log - 1][i + (1 << (log - 1))]);
            }
        }
    }

    inline item get(int l, int r){
        int log = lg[r - l + 1];
        return comb(sp[log][l], sp[log][r - (1 << log) + 1]);
    }
};

int n;
vector <ld> mn, mx;

inline ld check(ld &x, int &ind, sparse &sg, bool f = 0){
    mn.clear(), mx.clear();
    if (ind != 0)
        mn.eb(sg.get(0, ind - 1).mn);
    mn.eb(sg.get(ind, n - 1).mn * (1.0 - x));
    if (ind != 0)
        mx.eb(sg.get(0, ind - 1).mx);
    mx.eb(sg.get(ind, n - 1).mx * (1.0 - x));
    ld ans = -inf;

    for (auto i: mn){
        for (auto j: mx){
            ans = max(ans, abs(i - j));
        }
    }

    return ans;
}

void solve() {

    cin >> n;
    vector <int> a(n);

    for (int &i: a)
        cin >> i;

    sparse sg = sparse(a);
    ld l = EPS, r = 1;
    for (int i = 0; i < n; i++){
        l = 0, r = 1;
        for (int lg = 0; lg < 50; lg++){
            ld m1 = l + (r - l) / 3.0;
            ld m2 = r - (r - l) / 3.0;
            if (check(m1, i, sg) >= check(m2, i, sg))
                l = m1;
            else
                r = m2;
        }
        //cout << fixed << setprecision(20) << check(r, i, sg, 1) << '\n';
        cout << fixed << setprecision(20) << r << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //cin >> qqq;
    while (qqq--) {
        solve();
    }
    return 0;
}
