#include <unordered_map>
#include <functional>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <numeric>
#include <sstream>
#include <utility>
#include <string>
#include <vector>
#include <cstdio>
#include <bitset>
#include <random>
#include <cmath>
#include <deque>
#include <queue>
#include <stack>
#include <ctime>
#include <map>
#include <set>


//#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")

#define all(x) (x).begin(), (x).end()
#define an cerr << "-->"; cerr.flush()

using namespace std;

typedef	int ii;
typedef long long ll;
typedef long double ld;

const ld inf = 1e20 + 228;
const ll cst = (ll)1e5 + 5;
const ll mod = 998244353;
const ll maxlog = 20;

void operator delete(void* q);

void ex(ll exitCode = 0) {
#ifdef _DEBUG
    //system("pause");
#endif // _DEBUG
    exit(exitCode);
}

struct func {
    ll a, b, c;
    func(ll na = 0, ll nb = 0, ll nc = 0) {
        a = na;
        b = nb;
        c = nc;
    }
    func operator+(func th) {
        return func(a + th.a, b + th.b, c + th.c);
    }
    func operator-(func th) {
        return func(a - th.a, b - th.b, c - th.c);
    }
    func operator*(ll x) {
        return func(a * x, b * x, c * x);
    }
    ld operator()(ld x) {
        return (ld)a * x * x + (ld)b * x + (ld)c;
    }
    bool operator<(func that) {
        if(a != that.a) return a < that.a;
        if(b != that.b) return b < that.b;
        return c < that.c;
    }
    ll D() {
        return b * b - 4 * a * c;
    }
    pair<ld, ld> roots() {
        if (this->D() < 0) return { inf, -inf };
        if (a != 0) {
            ld r1 = -b + sqrtl(this->D());
            ld r2 = -b - sqrtl(this->D());
            r1 /= 2.0 * a;
            r2 /= 2.0 * a;
            return make_pair(r2, r1);
        }
        else {
            if (b != 0) return { -(ld)c / (ld)b, -(ld)c / (ld)b };
            else return { inf, -inf };
        }
    }
};

struct Event {
    ld x;
    ll t;
    func f;
    bool operator<(Event b) {
        return x < b.x;
    }
};

ll n;

vector<func> up;
vector<func> down;

deque<pair<ld, func>> split(vector<func>& vc) {
    deque<pair<ld, func>> d;
    for (ll i = 0; i < vc.size(); i++) {
        while (d.size()) {
            if (vc[i].a == d.back().second.a) {
                func f = vc[i] - d.back().second;
                if (f.b != 0) {
                    ld r = f.roots().second;
                    if (r < d.back().first + 1e-12) d.pop_back();
                    else {
                        d.push_back({ r, vc[i] });
                        break;
                    }
                }
                else d.pop_back();
            }
            else if (vc[i].a > d.back().second.a) {
                func f = vc[i] - d.back().second;
                ld r = f.roots().second;
                if (r < d.back().first + 1e-12) d.pop_back();
                else {
                    d.push_back({ r, vc[i] });
                    break;
                }
            }
        }
        if (d.empty()) d.push_back({ -inf, vc[i] });
        while (d.size()) {
            if (vc[i].a == d.front().second.a) break;
            else {
                func f = vc[i] - d.front().second;
                ld r = f.roots().first;
                if (r + 1e-12 > d[1].first) d.pop_front();
                else {
                    d[0].first = r;
                    d.push_front({ -inf, vc[i] });
                    break;
                }
            }
        }
    }
    return d;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin >> n;
    for (ll i = 0; i < n; i++) {
        ll a, b, c;
        cin >> a >> b >> c;
        if (a > 0) up.push_back({ a, b, c });
        else down.push_back(func{ a, b, c } * -1);
    }
    sort(all(up));
    sort(all(down));
    auto s1 = split(up);
    auto s2 = split(down);
    vector<Event> ElenaVladimirovna;
    for (auto i : s1) {
        Event e;
        e.x = i.first;
        e.t = 1;
        e.f = i.second;
        ElenaVladimirovna.push_back(e);
    }
    for (auto i : s2) {
        Event e;
        e.x = i.first;
        e.t = -1;
        e.f = i.second * -1;
        ElenaVladimirovna.push_back(e);
    }
    sort(all(ElenaVladimirovna));
    func fup, fdown;
    ld prv = -inf;
    ElenaVladimirovna.push_back({ inf, 0, fup });
    for (auto i : ElenaVladimirovna) {
        if (fup.a != 0 && fdown.a != 0) {
            func f = fup - fdown;
            pair<ld, ld> p = f.roots();
            p.first = max(p.first, prv);
            p.second = min(p.second, i.x);
            if (p.first + 1e-12 < p.second) {
                cout << setprecision(13) << fixed << (p.first + p.second) / 2.0 << " " << 0.5 * (fup + fdown)((p.first + p.second) / 2.0);
                ex();
            }
        }
        if (i.t == 1) fup = i.f;
        else fdown = i.f;
        prv = i.x;
    }
    ElenaVladimirovna.pop_back();
    prv = ElenaVladimirovna.back().x + 1.0;
    if (prv < 0) prv = 1.0;
    cout << setprecision(13) << fixed << prv << " " << ElenaVladimirovna.back().f(prv) + (ld)ElenaVladimirovna.back().f.a;
    ex();
}