#include <iostream>
#include <random>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <numeric>
#include <chrono>
#include <cassert>
#include <cmath>
#include <iomanip>

using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define int long long
using ll = long long;
using ld = long double;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const ld eps = 1e-15;
const int MAXN = 2e5;
int n;
int a[MAXN], b[MAXN], c[MAXN];

ld calc(int ind, ld x) {
    return a[ind] * x * x + b[ind] * x + c[ind];
}

ld f(ld x) {
    ld maxi = -1e18, mini = 1e18;

    for (int i = 0; i < n; i++) {
        ld val = calc(i, x);
        if (a[i] > 0) {
            if (val - maxi > eps) {
                maxi = val;
            }
        } else {
            if (val - mini < -eps) {
                mini = val;
            }
        }
    }

//    cout << setprecision(10) << fixed << x << ' ' << maxi << ' ' << mini << ' ' << maxi - mini << '\n';
    return maxi - mini;
}

ld getAns(ld x) {
    ld maxi = -1e18, mini = 1e18;

    for (int i = 0; i < n; i++) {
        ld val = calc(i, x);
        if (a[i] > 0) {
            if (val - maxi > eps) {
                maxi = val;
            }
        } else {
            if (val - mini < -eps) {
                mini = val;
            }
        }
    }

    return (maxi + mini) / 2;
}

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i] >> c[i];
    }

//    cout << f(-10) << '\n';
//    cout << f(0.25) << '\n';
//    cout << f(5) << '\n';
//    return;

    ld l = -1e9, r = 1e9;
    for (int i = 0; i < 200; i++) {
//        ld m1 = (2 * l + r) / 3;
//        ld m2 = (l + 2 * r) / 3;
        ld mid = (l + r) / 2;
//        cout << l << ' ' << r << ": " << f(mid) << ' ' << f(mid + 1e-6) << '\n';
        ld val = f(mid) - f(mid + eps);
//        cout << val << '\n';
        if (val > eps) {
            l = mid;
        } else {
            r = mid;
        }
    }

    std::cout << setprecision(10) << fixed << l << ' ' << getAns(l) << '\n';
}

signed main() {
//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);

    solve();
//    int t; cin >> t; while(t--) solve();
}
