//
// Created by olymp on 12.12.2021.
//
#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <iomanip>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define ar array
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;

using namespace std;
const ll INF = 2e18;

struct SegTree {
    vector<ll> t;
    int n;

    void build(vector<ll> &a) {
        n = (int)a.size() + 2;
        t.resize(n * 2, INF);
        for(int i = 0; i < (int)a.size(); ++i) {
            t[i + n] = a[i];
        }
        for(int i = n - 1; i >= 1; --i) {
            t[i] = min(t[i << 1], t[i << 1 | 1]);
        }
    }

    ll get(int l, int r) {
        ll res = INF;
        for(l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) res = min(res, t[l++]);
            if (r & 1) res = min(res, t[--r]);
        }
        return res;
    }
};

const int md = 1e9 + 7;

int add(int a, int b) {
    return a + b >= md ? a + b - md : a + b;
}

int sub(int a, int b) {
    return a - b < 0 ? a - b + md : a - b;
}

int mul(int a, int b) {
    return (1ll * a * b) % md;
}

void solve() {
    int n, k; cin >> n >> k;
    vector<int> a(n), b(n);
    rep(i, n) cin >> a[i] >> b[i];
    SegTree st;
    vector<ll> c(n);
    rep(i, n) {
        if (a[i] < b[i]) swap(a[i], b[i]);
        ll x = a[i] - b[i];
        if ((x % k) == 0) {
            c[i] = INF;
        } else {
            c[i] = x;
        }
    }
    st.build(c);
    vector<ll> kek(n + 1);
    for(int i = 0; i < n; ++i) {
        ll value = kek[i] + a[i];
        value %= k;
        kek[i + 1] = value;
    }
    vector<int> ord(n + 1);
    iota(all(ord), 0);
    sort(all(ord), [&] (const int &i, const int &j) {
        return pair<ll, int>{kek[i], i} < pair<ll, int> {kek[j], j};
    });
    vector<int> pref(n + 1);
    vector<int> sumpref(n + 1);
    {
        for (int i = 1; i <= n; ++i) {
            pref[i] = add(pref[i - 1], a[i - 1] % md);
            sumpref[i] = add(sumpref[i - 1], pref[i]);
        }
    }
    int ans = 0;
    for(int l = 0, r = 0; l <= n; l = r) {
        while(r <= n && kek[ord[r]] == kek[ord[l]]) r++;
        vector<ar<ll, 4>> stk;
        int p = ord[l];
        int bad = 0;
        for(int i = l; i < r; ++i) {
            int j = ord[i];
            int res = sub(0, sumpref[j]);
            res = add(res, mul(pref[j], j + 1));
            ans = add(ans, res);
            if (p < j) {
                ll val = st.get(p, j);
                int L = i - l - 1;
                int R = i - l - 1;
                int s = pref[ord[i - 1]];
                while(!stk.empty() && val <= stk.back()[0]) {
                    auto [val1, l1, r1, s2] = stk.back();
                    stk.pop_back();
                    L = l1;
                    s = add(s, s2);
                    if (val1 != INF) {
                        bad = add(bad, mul(val1 % md, r1 - l1 + 1));
                    }
                }
                if (val != INF) {
                    bad = sub(bad, mul(val % md, R - L + 1));
                }
                stk.push_back({val, L, R, s});
                p = j;
            }
            ans = add(ans, bad);
            if (!stk.empty() && stk.back()[0] == INF) {
                auto [val1, l1, r1, s1] = stk.back();
                ans = sub(ans, sub(mul(pref[j], r1 - l1 + 1), s1));
            }
        }
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout << setprecision(15) << fixed;
    int t = 1;
    rep(_, t) {
        solve();
    }
    return 0;
}