#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(a) (a).begin(), (a).end()
#define len(a) int((a).size())

template<typename A, typename B>
ostream& operator<<(ostream &out, pair<A, B> p) { return out << '(' << p.first << ", " << p.second << ')'; }

template<typename A, typename B = typename enable_if<!is_same<A, string>::value, typename A::value_type>::type>
ostream& operator<<(ostream &out, A vec) { out << '{'; string sep; for (B x : vec) out << sep << x, sep = ", "; return out << '}'; }

void dbg_print() { cerr << endl; }
template<typename A, typename... B> void dbg_print(A a, B... b) { cerr << ' ' << a; dbg_print(b...); }

#ifdef LOCAL
    #define dbg(...) cerr << '#' << __LINE__ << " [" << #__VA_ARGS__ << "]:", dbg_print(__VA_ARGS__)
#else
    #define dbg(...)
#endif

const int N = 1e6 + 1, A = 26, LG = 21;
int childs[N][A], parent[N][LG], depth[N], go[N][A], answer[N], term[N], id = 0, sz[N];

int new_node(int p) {
    if (p != id)
        depth[id] = depth[p] + 1;

    parent[id][0] = p;
    for (int i = 1; i < LG; i++)
        parent[id][i] = parent[parent[id][i - 1]][i - 1];

    for (int i = 0; i < A; i++) {
        childs[id][i] = -1;
        go[id][i] = id;
    }
    return id++;
}

int cur = 0;

void dfs(int v) {
    answer[v] = cur;
    cur += term[v];
    for (int i = 0; i < A; i++)
        if (childs[v][i] != -1)
            dfs(childs[v][i]);
}

signed main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

    int n, q;
    string s;
    cin >> n >> q >> s;

    int root = new_node(0);
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;

        int v = root;
        for (int i = 0; i < len(s); i++) {
            if (childs[v][s[i] - 'a'] == -1)
                childs[v][s[i] - 'a'] = new_node(v);

            v = childs[v][s[i] - 'a'];
        }
        term[v]++;
    }

    for (int i = id - 1; i >= 0; i--) {
        sz[i] = term[i];
        for (int j = 0; j < A; j++)
            if (childs[i][j] != -1) {
                go[i][j] = go[childs[i][j]][j];
                sz[i] += sz[childs[i][j]];
            }
    }

    dfs(root);

    int where = 0;
    for (auto c : s)
        if (childs[where][c - 'a'] != -1)
            where = childs[where][c - 'a'];
        else
            break;

    auto solve = [&](char c) {
        if (depth[where] == len(s)) {
            cout << answer[where] << '\n';
            return;
        }

        int res = answer[where];
        res += term[where];
        assert(childs[where][c - 'a'] == -1);
        for (int i = 0; i < c - 'a'; i++)
            if (childs[where][i] != -1)
                res += sz[childs[where][i]];

        cout << res << '\n';
    };

    char last = depth[where] == len(s) ? 'a' + 26 : s[depth[where]];
    solve(last);

    while (q--) {
        int pos;
        char c;
        cin >> pos >> c;
        pos--;

        if (depth[where] > pos) {
            int delta = depth[where] - pos;
            for (int i = LG - 1; i >= 0; i--)
                if (delta >> i & 1)
                    where = parent[where][i];
        }

        if (depth[where] == pos) {
            where = go[where][c - 'a'];
            for (int i = LG - 1; i >= 0; i--)
                if (depth[parent[where][i]] >= len(s))
                    where = parent[where][i];

            last = c;
        }

        solve(depth[where] == len(s) ? 'a' + 26 : last);
    }
}
