#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(a) (a).begin(), (a).end()
#define len(a) int((a).size())

template<typename A, typename B>
ostream& operator<<(ostream &out, pair<A, B> p) { return out << '(' << p.first << ", " << p.second << ')'; }

template<typename A, typename B = typename enable_if<!is_same<A, string>::value, typename A::value_type>::type>
ostream& operator<<(ostream &out, A vec) { out << '{'; string sep; for (B x : vec) out << sep << x, sep = ", "; return out << '}'; }

void dbg_print() { cerr << endl; }
template<typename A, typename... B> void dbg_print(A a, B... b) { cerr << ' ' << a; dbg_print(b...); }

#ifdef LOCAL
    #define dbg(...) cerr << '#' << __LINE__ << " [" << #__VA_ARGS__ << "]:", dbg_print(__VA_ARGS__)
#else
    #define dbg(...)
#endif

template<typename T>
int normalize(T value, int mod) {
    if (value < -mod || value >= 2 * mod)
        value %= mod;

    if (value < 0)
        value += mod;

    if (value >= mod)
        value -= mod;

    return value;
}

template<int mod>
struct static_modular_int {
    using mint = static_modular_int<mod>;

    int value;

    static_modular_int() : value(0) {}
    static_modular_int(const mint &x) : value(x.value) {}

    template<typename T>
    static_modular_int(T value) : value(normalize(value, mod)) {}

    template<typename T>
    mint power(T degree) const {
        degree = normalize(degree, mod - 1);
        mint prod = 1;
        mint a = *this;

        for (; degree > 0; degree >>= 1, a *= a)
            if (degree & 1)
                prod *= a;

        return prod;
    }

    mint inv() const {
        return power(-1);
    }

    mint& operator=(const mint &x) {
        value = x.value;
        return *this;
    }

    mint& operator+=(const mint &x) {
        value += x.value;
        if (value >= mod)
            value -= mod;

        return *this;
    }

    mint& operator-=(const mint &x) {
        value -= x.value;
        if (value < 0)
            value += mod;

        return *this;
    }

    mint& operator*=(const mint &x) {
        value = (long long) value * x.value % mod;
        return *this;
    }

    mint& operator/=(const mint &x) {
        return *this *= x.inv();
    }

    friend mint operator+(const mint &x, const mint &y) {
        return mint(x) += y;
    }

    friend mint operator-(const mint &x, const mint &y) {
        return mint(x) -= y;
    }

    friend mint operator*(const mint &x, const mint &y) {
        return mint(x) *= y;
    }

    friend mint operator/(const mint &x, const mint &y) {
        return mint(x) /= y;
    }

    mint& operator++() {
        ++value;
        if (value == mod)
            value = 0;

        return *this;
    }

    mint& operator--() {
        --value;
        if (value == -1)
            value = mod - 1;

        return *this;
    }

    mint operator++(int) {
        value++;
        if (value == mod)
            value = 0;

        return *this;
    }

    mint operator--(int) {
        value--;
        if (value == -1)
            value = mod - 1;

        return *this;
    }

    mint operator-() {
        return mint(0) - *this;
    }

    template<typename T>
    explicit operator T() {
        return value;
    }

    friend istream& operator>>(istream &in, mint &x) {
        std::string s;
        in >> s;

        x = 0;
        for (const auto c : s)
            x = x * 10 + (c - '0');

        return in;
    }

    friend ostream& operator<<(ostream &out, const mint &x) {
        return out << x.value;
    }
};

constexpr int MOD = 1'000'000'007;
// constexpr int MOD = 998'244'353;
using mint = static_modular_int<MOD>;

struct sparse_table {
	vector<vector<int>> sparse;

	sparse_table(const vector<int> &a) {
		int n = len(a);
		sparse.push_back(a);
		for (int i = 1; (1 << i) <= n; i++) {
			sparse.push_back(vector<int>(n - (1 << i) + 1));
			for (int j = 0; j < len(sparse.back()); j++)
				sparse[i][j] = min(sparse[i - 1][j], sparse[i - 1][j + (1 << (i - 1))]);
		}
	}

	int query(int l, int r) {
		int level = __lg(r - l);
		return min(sparse[level][l], sparse[level][r - (1 << level)]);
	}
};

signed main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	int n, k;
	cin >> n >> k;

	vector<int> a(n), b(n), delta(n, INT_MAX);
	for (int i = 0; i < n; i++) {
		cin >> a[i] >> b[i];
		if (a[i] < b[i])
			swap(a[i], b[i]);

		if ((b[i] - a[i]) % k != 0)
			delta[i] = a[i] - b[i];
	}

	vector<ll> pref(n + 1);
	for (int i = 0; i < n; i++)
		pref[i + 1] = pref[i] + a[i];

	sparse_table sparse(delta);

	map<int, vector<int>> occ;
	for (int i = 0; i <= n; i++)
		occ[pref[i] % k].push_back(i);

	mint answer = 0;
	for (int i = 0; i < n; i++)
		answer += mint(i + 1) * (n - i) * a[i];

	// dbg(answer);

	for (auto &[_, positions] : occ) {
		// dbg(positions);

		int m = len(positions);
		mint sum = 0;
		for (int i = 0, j = 0; i < m; i++) {
			while (j < i && sparse.query(positions[j], positions[i]) != INT_MAX) {
				sum -= mint(pref[positions[j]]);
				j++;
			}

			// dbg(i, j);
			// dbg(mint(i - j) * pref[positions[i]] - sum);
			answer -= mint(i - j) * pref[positions[i]] - sum;
			sum += mint(pref[positions[i]]);
		}

		vector<pair<int, int>> st;
		vector<mint> dt;

		for (int i = 0; i < m; i++) {
			if (!st.empty()) {
				// dbg(i, st, dt);
				// dbg(dt.back());
				answer -= dt.back();
			}

			if (i == m - 1)
				continue;

			int cur = sparse.query(positions[i], positions[i + 1]);
			if (cur == INT_MAX)
				continue;

			while (!st.empty() && st.back().second >= cur) {
				st.pop_back();
				dt.pop_back();
			}

			dt.push_back((dt.empty() ? 0 : dt.back()) + mint(i - (st.empty() ? -1 : st.back().first)) * cur);
			st.emplace_back(i, cur);
		}
	}

	cout << answer << '\n';
}
