#pragma GCC optimize("Ofast,unroll-all-loops")
#pragma GCC optimize("O3")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2")
//#pragma GCC target("popcnt")

#include "bits/stdc++.h"
#include <numeric>

using namespace std;

template<typename A, typename B>
string to_string(pair<A, B> p);

template<typename A, typename B, typename C>
string to_string(tuple<A, B, C> p);

template<typename A, typename B, typename C, typename D>
string to_string(tuple<A, B, C, D> p);

string to_string(const string &s) {
    return '"' + s + '"';
}

string to_string(const char *s) {
    return to_string((string) s);
}

string to_string(bool b) {
    return (b ? "true" : "false");
}

string to_string(vector<bool> v) {
    bool first = true;
    string res = "{";
    for (int i = 0; i < static_cast<int>(v.size()); i++) {
        if (!first) {
            res += ", ";
        }
        first = false;
        res += to_string(v[i]);
    }
    res += "}";
    return res;
}

template<size_t N>
string to_string(bitset<N> v) {
    string res = "";
    for (size_t i = 0; i < N; i++) {
        res += static_cast<char>('0' + v[i]);
    }
    return res;
}

template<typename A>
string to_string(A v) {
    bool first = true;
    string res = "{";
    for (const auto &x : v) {
        if (!first) {
            res += ", ";
        }
        first = false;
        res += to_string(x);
    }
    res += "}";
    return res;
}

template<typename A, typename B>
string to_string(pair<A, B> p) {
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template<typename A, typename B, typename C>
string to_string(tuple<A, B, C> p) {
    return "(" + to_string(get<0>(p)) + ", " +
           to_string(get<1>(p)) + ", " + to_string(get<2>(p)) + ")";
}

template<typename A, typename B, typename C, typename D>
string to_string(tuple<A, B, C, D> p) {
    return "(" + to_string(get<0>(p)) + ", " + to_string(get<1>(p)) +
           ", " + to_string(get<2>(p)) + ", " +
           to_string(get<3>(p)) + ")";
}

void debug_out() { cerr << endl; }

template<typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
    cerr << " " << to_string(H);
    debug_out(T...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", \
                   debug_out(__VA_ARGS__)
#else
#define debug(...)
#endif

#define sz(a) (ll)((a).size())
#define all(v) (v).begin(), (v).end()
#define rall(v) v.rbegin(), v.rend()
#define pikachu push_back
#define mp make_pair
#define st first
#define nd second
#define i128 __int128
#define pt(s) (s)[sz((s)) - 2]
#define pll pair<ll, ll>
#define pii pair<int, int>

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<class t1, class t2>
inline bool cmin(t1 &a, const t2 &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<class t1, class t2>
inline bool cmax(t1 &a, const t2 &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

typedef long long ll;
typedef unsigned int uint;
typedef unsigned long long ull;
typedef long double ld;
const ll INFL = 2e18l + 666;
const int INFI = 2e9 + 7;
inline ull bpow(ull a, ull b, ull mod = INFL) {
    ull res = 1;
    for (; b; b >>= 1) {
        if (b & 1) {
            res = ((ull) 1ll * res * a) % mod;
        }
        a = ((ull) 1ll * a * a) % mod;
    }
    return res;
}
#ifndef LOCAL
void UseFiles(const string &s) {
    freopen((s + ".in").c_str(), "r", stdin);
    freopen((s + ".out").c_str(), "w", stdout);
}
#else

void UseFiles(const string &) {}

#endif
void run();
signed main() {
    iostream::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << setprecision(10) << fixed;
    //UseFiles("triangles");
    run();
}
const ll K = 26;
bool ans = 1;
void calc(vector<string> s, vector<char> used) {
    if (sz(s) == 1) return;
    vector<int> ct(K, 0);
    for (auto &str : s) {
        vector<char> fl(K, 0);
        for (auto e : str)
            if (!fl[e]) {
                fl[e] = 1;
                ct[e]++;
            }
    }
    ll c = -1;
    for (ll i = 0; i < K; ++i) {
        if (ct[i] == sz(s) && !used[i]) c = i;
    }
    if (c == -1) {
        ans = 0;
        return;
    }
    used[c] = 1;
    unordered_map<string, vector<string>> mp;
    for (ll i = 0; i < sz(s); ++i) {
        string num;
        for (ll j = 0; j < sz(s[i]); ++j) {
            if (s[i][j] == c) num += to_string(j), num.pikachu('!');
        }
        mp[num].pikachu(s[i]);
    }
    for (auto &[kod, ind] : mp) {
        calc(ind, used);
    }
}
void run() {
    ll L, n;
    cin >> L >> n;
    vector<string> s;
    for (ll i = 0; i < n; ++i) {
        string str;
        cin >> str;
        for (auto &e : str) e -= 'a';
        s.pikachu(str);
    }
    vector<char> used(K, 0);
    calc(s, used);
    if (ans) cout << "YES\n";
    else
        cout << "NO\n";
}