#include <bits/stdc++.h>

using namespace std;


struct node_t {
	array<map<char, int>, 20> next_bin;
	int cnt_less;
	int cnt;
	int depth;
	int sum;

	node_t(int depth): cnt_less(0), cnt(0), depth(depth), sum(0) {
	}
};

vector<node_t> nodes;


void add_string(const string& s) {
	int node = 0;
	for(char c: s) {
		if(!nodes[node].next_bin[0].count(c)) {
			nodes[node].next_bin[0][c] = nodes.size();
			nodes.emplace_back(nodes[node].depth + 1);
		}
		node = nodes[node].next_bin[0][c];
	}
	nodes[node].cnt++;
}


void dfs(int node, int in_cnt_less) {
	nodes[node].cnt_less = in_cnt_less;
	nodes[node].sum = nodes[node].cnt;
	for(auto [c, chld]: nodes[node].next_bin[0]) {
		if(c != '~') {
			dfs(chld, nodes[node].cnt_less + nodes[node].sum);
			nodes[node].sum += nodes[chld].sum;
		}
	}

	for(int i = 1; i < 20; i++) {
		for(auto [c, v]: nodes[node].next_bin[i - 1]) {
			if(nodes[v].depth - nodes[node].depth < (1 << (i - 1)) || !nodes[v].next_bin[i - 1].count(c)) {
				nodes[node].next_bin[i][c] = v;
			} else {
				nodes[node].next_bin[i][c] = nodes[v].next_bin[i - 1][c];
			}
		}
	}
}


void down(int& node, char c, int j, bool& complete) {
	auto it = nodes[node].next_bin[j].find(c);
	if(it != nodes[node].next_bin[j].end()) {
		complete = nodes[it->second].depth - nodes[node].depth == (1 << j);
		node = it->second;
	} else {
		complete = false;
	}
}


int count_node(char c, int n, int node, bool complete) {
	if(!complete) {
		return 0;
	}

	int mod = nodes[node].cnt_less;

	for(int j = 19; j >= 0 && node != -1 && complete; j--) {
		if((n >> j) & 1) {
			down(node, c, j, complete);
		}
	}

	int ans = nodes[node].cnt_less;
	if(!complete) {
		auto it = nodes[node].next_bin[0].lower_bound(c);
		assert(it->first != c);
		ans += nodes[node].cnt;
		while(it != nodes[node].next_bin[0].begin()) {
			ans += nodes[(--it)->second].sum;
		}
	}

	return ans - mod;
}


signed main() {
	nodes.emplace_back(0);


	int n, q;
	cin >> n >> q;

	vector<tuple<int, char, int, int, bool>> ss;
	string s;
	cin >> s;
	for(int i = 0; i < s.size(); i++) {
		ss.emplace_back(i, s[i], 1, -1, true);
	}

	for(int i = 0; i < n; i++) {
		string t;
		cin >> t;
		add_string(t);
	}

	dfs(0, 0);


	int ans = 0;
	int node = 0;
	bool complete = true;
	for(int i = 0; i < s.size(); i++) {
		get<3>(ss[i]) = node;
		get<4>(ss[i]) = complete;
		if(complete) {
			down(node, s[i], 0, complete);
			if(!complete) {
				auto it = nodes[node].next_bin[0].lower_bound(s[i]);
				assert(it->first != s[i]);
				ans += nodes[node].cnt;
				while(it != nodes[node].next_bin[0].begin()) {
					ans += nodes[(--it)->second].sum;
				}
			}
		}
	}
	ans += nodes[node].cnt_less;
	cout << ans << "\n";

	for(int i = 0; i < q; i++) {
		int k;
		char c;
		cin >> k >> c;
		k--;

		int exp;
		auto it = lower_bound(ss.begin(), ss.end(), make_tuple(k, 0, 0, 0, false));
		if(it != ss.begin()) {
			--it;

			auto& [i, c, n, node, complete] = *it;

			assert(k == 0 || i < k);
			assert(i + n >= k);

			ans -= count_node(c, n, node, complete);
			n = k - i;
			ans += count_node(c, n, node, complete);

			exp = it - ss.begin() + 1;
		} else {
			exp = 0;
		}

		while(ss.size() > exp) {
			auto [i, c, n, node, complete] = ss.back();
			ans -= count_node(c, n, node, complete);
			ss.pop_back();
		}

		int node;
		int complete;
		if(ss.empty()) {
			node = 0;
			complete = true;
		} else {
			int i, c, n;
			tie(i, c, n, node, complete) = ss.back();
			for(int j = 19; j >= 0 && complete; j--) {
				if((n >> j) & 1) {
					auto it = nodes[node].next_bin[j].lower_bound(c);
					if(it->first == c && nodes[it->second].depth - nodes[node].depth == (1 << j)) {
						node = it->second;
					} else {
						complete = false;
					}
				}
			}
		}

		int n = s.size() - k;
		ss.emplace_back(k, c, n, node, complete);
		ans += count_node(c, n, node, complete);

		cout << ans << "\n";
	}

	return 0;
}
