#include <bits/stdc++.h>

using namespace std;


struct node_t {
	array<int, 26> children;
	array<pair<int, int>, 26> next;
	int cnt_less;
	int cnt;
	int depth;
	int sum;

	node_t(int depth): cnt_less(0), cnt(0), depth(depth), sum(0) {
		for(int i = 0; i < 26; i++) {
			children[i] = -1;
			next[i] = {-1, -1};
		}
	}
};

vector<node_t> nodes;


void add_string(const string& s) {
	int node = 0;
	for(char c: s) {
		if(nodes[node].children[c] == -1) {
			nodes[node].children[c] = nodes.size();
			nodes.emplace_back(nodes[node].depth + 1);
		}
		node = nodes[node].children[c];
	}
	nodes[node].cnt++;
}


void dfs(int node, int in_cnt_less) {
	nodes[node].cnt_less = in_cnt_less;
	nodes[node].sum = nodes[node].cnt;
	for(char c = 0; c < 26; c++) {
		int chld = nodes[node].children[c];
		if(chld != -1) {
			dfs(chld, nodes[node].cnt_less + nodes[node].sum);
			nodes[node].sum += nodes[chld].sum;
			if(nodes[chld].next[c].first == -1 || nodes[nodes[chld].next[c].first].next[c].first == -1 || nodes[chld].next[c].second != nodes[nodes[chld].next[c].first].next[c].second) {
				nodes[node].next[c] = {chld, 1};
			} else {
				nodes[node].next[c] = {nodes[nodes[chld].next[c].first].next[c].first, nodes[chld].next[c].second * 2 + 1};
			}
		}
	}
}


void down(int& node, char c, int n, bool& complete) {
	while(n > 0 && complete) {
		if(nodes[node].next[c].first == -1) {
			complete = false;
			return;
		}
		if(nodes[node].next[c].second <= n) {
			n -= nodes[node].next[c].second;
			node = nodes[node].next[c].first;
		} else {
			node = nodes[node].children[c];
			n--;
		}
	}
}


int count_node(char c, int n, int node, bool complete) {
	if(!complete) {
		return 0;
	}

	int mod = nodes[node].cnt_less;

	down(node, c, n, complete);

	int ans = nodes[node].cnt_less;
	if(!complete) {
		ans += nodes[node].cnt;
		for(int i = 0; i < c; i++) {
			if(nodes[node].children[i] != -1) {
				ans += nodes[nodes[node].children[i]].sum;
			}
		}
	}

	return ans - mod;
}


signed main() {
	nodes.emplace_back(0);


	int n, q;
	cin >> n >> q;

	vector<tuple<int, char, int, int, bool>> ss;
	string s;
	cin >> s;
	for(int i = 0; i < s.size(); i++) {
		s[i] -= 'a';
		ss.emplace_back(i, s[i], 1, -1, true);
	}

	for(int i = 0; i < n; i++) {
		string t;
		cin >> t;
		for(char& c: t) {
			c -= 'a';
		}
		add_string(t);
	}

	dfs(0, 0);


	int ans = 0;
	int node = 0;
	bool complete = true;
	for(int i = 0; i < s.size(); i++) {
		get<3>(ss[i]) = node;
		get<4>(ss[i]) = complete;
		if(complete) {
			if(nodes[node].children[s[i]] != -1) {
				complete = true;
				node = nodes[node].children[s[i]];
			} else {
				complete = false;
				ans += nodes[node].cnt;
				for(int j = 0; j < s[i]; j++) {
					if(nodes[node].children[j] != -1) {
						ans += nodes[nodes[node].children[j]].sum;
					}
				}
			}
		}
	}
	ans += nodes[node].cnt_less;
	cout << ans << "\n";

	for(int i = 0; i < q; i++) {
		int k;
		char c;
		cin >> k >> c;
		c -= 'a';
		k--;

		int exp;
		auto it = lower_bound(ss.begin(), ss.end(), make_tuple(k, 0, 0, 0, false));
		if(it != ss.begin()) {
			--it;

			auto& [i, c, n, node, complete] = *it;

			assert(k == 0 || i < k);
			assert(i + n >= k);

			ans -= count_node(c, n, node, complete);
			n = k - i;
			ans += count_node(c, n, node, complete);

			exp = it - ss.begin() + 1;
		} else {
			exp = 0;
		}

		while(ss.size() > exp) {
			auto [i, c, n, node, complete] = ss.back();
			ans -= count_node(c, n, node, complete);
			ss.pop_back();
		}

		int node;
		bool complete;
		if(ss.empty()) {
			node = 0;
			complete = true;
		} else {
			int i, c, n;
			tie(i, c, n, node, complete) = ss.back();
			down(node, c, n, complete);
		}

		int n = s.size() - k;
		ss.emplace_back(k, c, n, node, complete);
		ans += count_node(c, n, node, complete);

		cout << ans << "\n";
	}

	return 0;
}
