#include <bits/stdc++.h>

using namespace std;

#define int long long


using ld = long double;

const ld EPS = 0.00001;


ld cost(const array<ld, 4>& aa) {
	return aa[0] * aa[3] + aa[1] + aa[2];
}

ld cmp_var_cost(const array<ld, 4>& aa, const array<ld, 4>& bb) {
	return cost(aa) < cost(bb);
}


array<ld, 4> solve(const array<int, 4>& perm, const array<ld, 4>& aa) {
	array<ld, 4> bb;
	for(int i = 0; i < 4; i++) {
		bb[i] = aa[perm[i]];
	}

	array<ld, 4> xx = {
		1 + (bb[1] - 1) * (bb[2] - 1) / (bb[3] - 1),
		1 + (bb[0] - 1) * (bb[3] - 1) / (bb[2] - 1),
		1 + (bb[0] - 1) * (bb[3] - 1) / (bb[1] - 1),
		1 + (bb[1] - 1) * (bb[2] - 1) / (bb[0] - 1)
	};

	vector<array<ld, 4>> variants;
	for(int i = 0; i < 4; i++) {
		if(bb[i] - xx[i] > EPS) {
			auto bb1 = bb;
			bb1[i] = xx[i];
			variants.emplace_back(bb1);
		}
	}

	if(abs((bb[0] * bb[3] + bb[1] + bb[2]) - (bb[1] * bb[2] + bb[0] + bb[3])) < EPS) {
		variants.emplace_back(bb);
	}

	return *max_element(variants.begin(), variants.end(), cmp_var_cost);
}


signed main() {
	array<ld, 4> aa;
	for(ld& x: aa) {
		cin >> x;
	}

	array<int, 4> perm;
	iota(perm.begin(), perm.end(), 0);

	ld max_cost = -1;
	array<int, 4> max_perm;
	array<ld, 4> max_bb;

	do {
		array<ld, 4> bb = solve(perm, aa);
		array<ld, 4> cc;
		for(int i = 0; i < 4; i++) {
			cc[perm[i]] = bb[i];
		}
		if(cost(cc) > max_cost) {
			max_cost = cost(cc);
			max_perm = perm;
			max_bb = bb;
		}
	} while(next_permutation(perm.begin(), perm.end()));

	for(int x: max_perm) {
		cout << x + 1 << " ";
	}
	cout << endl;

	cout << fixed << setprecision(10);
	for(ld x: max_bb) {
		cout << x << " ";
	}
	cout << endl;

	return 0;
}
