from math import sqrt


def get_y(a, b, c, x):
    return a * x ** 2 + b * x + c


def check(x, y):
    for a, b, c in lines:
        if a > 0 and get_y(a, b, c, x) > y:
            return False
        if a < 0 and get_y(a, b, c, x) < y:
            return False
    return True


n = int(input())

lines = [tuple(map(int, input().split())) for _ in range(n)]
lines.sort()

x_l = -float('inf')
x_r = float('inf')

for i in range(n):
    for j in range(i + 1, n):
        a, b, c = lines[i]
        a1, b1, c1 = lines[j]

        d = (b - b1) ** 2 - 4 * (a - a1) * (c - c1)

        if d < 0 or a == a1:
            continue

        x1 = (-(b - b1) - sqrt(d)) / (2 * (a - a1))
        x2 = (-(b - b1) + sqrt(d)) / (2 * (a - a1))
        x1, x2 = min(x1, x2), max(x1, x2)

        x_l = max(x_l, x1)
        x_r = min(x_r, x2)

y_min = -float('inf')
y_max = float('inf')
for a, b, c in lines:
    if a > 0:
        y_min = max(y_min, get_y(a, b, c, x_l))
    else:
        y_max = min(y_max, get_y(a, b, c, x_l))

# print(x_l, x_r)
# print(y_min, y_max)

if check(x_l, y_min):
    print(f'{x_l:.10f} {y_min:.10f}')
elif check(x_r, y_max):
    print(f'{x_l:.10f} {y_min:.10f}')
