#include <bits/stdc++.h>

constexpr uint64_t mod = (1ull << 61) - 1;
constexpr uint64_t base = 1e9 + 7;

constexpr uint64_t mul(uint64_t a, uint64_t b) {
    __uint128_t res = a * __uint128_t(1) * b;
    uint64_t r = (res >> 61) + (res & mod);
    r = (r >> 61) + (r & mod);
    return r;
}
constexpr uint64_t add(uint64_t a, uint64_t b) {
    return a + b - (a + b >= mod) * mod;
}
constexpr uint64_t power(uint64_t b, uint64_t e) {
    uint64_t r = 1;
    for (; e > 0; e >>= 1) {
        if (e % 2) {
            r = mul(r, b);
        }
        b = mul(b, b);
    }
    return r;
}

uint64_t hash(const std::vector<int>& vec) {
    uint64_t p = 1;
    uint64_t r = 0;
    for (int i = 0; i < vec.size(); i++) {
        r = add(r, mul(vec[i] + 100, p));
        p = mul(p, base);
    }
    return r;
}

constexpr int K = 26;

using Data = std::array<std::vector<int>, K>;

bool solve(std::vector<Data>& vec) {
    if (vec.size() <= 1) {
        return true;
    }
    int mask = (1 << K) - 1;
    for (Data& d : vec) {
        for (int i = 0; i < K; i++) {
            if (d[i].empty() && ((mask >> i) & 1)) {
                mask ^= (1 << i);
            }
        }
    }
    if (mask == 0) {
        return false;
    }

    int k = __builtin_ctz(mask);

    std::map<uint64_t, std::vector<Data>> mp;
    for (int i = 0; i < vec.size(); i++) {
        uint64_t h = hash(vec[i][k]);
        vec[i][k].clear();
        vec[i][k].shrink_to_fit();
        mp[h].push_back(vec[i]);

        for (auto& v : vec[i]) {
            v.clear();

            v.shrink_to_fit();
        }
    }
    for (auto& [k, v] : mp) {
        if (!solve(v)) {
            return false;
        }
    }
    return true;
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int l, n;
    std::cin >> l >> n;
    std::vector<Data> input(n);
    for (auto& d : input) {
        std::string s;
        std::cin >> s;
        for (int i = 0; i < l; i++) {
            d[s[i] - 'a'].push_back(i);
        }
    }

    std::cout << (solve(input) ? "YES\n" : "NO\n");

    return 0;
}