#include <iostream>
#include <queue>
using namespace std;
using ll = long long;

const int MAXN = 1e6 + 177013;
ll a[MAXN];
ll b[MAXN];

bool sim(int n, ll mxdist) {
    int j = 0;
    ll bj = b[0];
    ll ai = 0;
    for (int i = 0; i < n; ++i) {
        ai = a[i];
        while (i - j > mxdist) {
            ++j;
            bj = b[j];
        }
        while (ai) {
            if (j >= n || j - i > mxdist)
                return false;
            ll k = min(ai, bj);
            bj -= k;
            ai -= k;
            if (bj == 0) {
                ++j;
                if (j < n)
                    bj = b[j];
            }
        }
    }
    return true;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    for (int j = 0; j < n; ++j)
        cin >> b[j];
    ll lb = -1, ub = n + 123;
    while (ub - lb > 1) {
        ll mb = (lb + ub) / 2;
        if (sim(n, mb)) {
            ub = mb;
        } else {
            lb = mb;
        }
    }
    if (ub == n + 123) {
        cout << -1 << endl;
    } else {
        cout << ub << endl;
    }
}
