from collections import *

INF = 10 ** 9 + 7


class KeepMin:
    def __init__(self):
        self.a = deque()

    def append(self, elem):
        while self.a and self.a[-1] > elem:
            self.a.pop()
        self.a.append(elem)

    def pop(self, elem):
        if self.a[0] == elem:
            self.a.popleft()

    def get_min(self):
        return self.a[0]


class KeepMax:
    def __init__(self):
        self.a = deque()

    def append(self, elem):
        while self.a and self.a[-1] < elem:
            self.a.pop()
        self.a.append(elem)

    def pop(self, elem):
        if self.a[0] == elem:
            self.a.popleft()

    def get_max(self):
        return self.a[0]


# inp = open("input.txt", "r")

n = int(input())
# n = int(inp.readline())
a = list(map(int, input().split()))
# a = list(map(int, inp.readline().split()))

# print("READ")

left_min = KeepMin()
left_max = KeepMax()
left_min.append(INF)
left_max.append(0)

right_min = KeepMin()
right_max = KeepMax()

for i in range(n):
    right_min.append(a[i])
    right_max.append(a[i])

for k in range(n):
    tmin = 1.0
    if right_min.get_min() > left_min.get_min():
        tmin = left_min.get_min() / right_min.get_min()

    tmax = 1.0
    if right_max.get_max() > left_max.get_max():
        tmax = left_max.get_max() / right_max.get_max()

    nspr_min = max(right_max.get_max() * tmin, left_max.get_max()) - min(right_min.get_min() * tmin, left_min.get_min())
    nspr_max = max(right_max.get_max() * tmax, left_max.get_max()) - min(right_min.get_min() * tmax, left_min.get_min())

    if nspr_min < nspr_max:
        print(1 - tmin, end=' ')
    elif nspr_max < nspr_min:
        print(1 - tmax, end=' ')
    else:
        print(1 - min(tmax, tmin), end=' ')

    left_min.append(a[k])
    left_max.append(a[k])
    right_min.pop(a[k])
    right_max.pop(a[k])
