#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <tuple>
#include <deque>
#include <iomanip>
#define ll long long
using namespace std;

const int INF = 1e9 + 7;

struct KeepMin {
	deque<int> a;

	void append(int elem) {
		while (!a.empty() && a.back() > elem)
			a.pop_back();
		a.push_back(elem);
	}

	void pop(int elem) {
		if (a.front() == elem)
			a.pop_front();
	}

	int get() {
		return a.front();
	}
};

struct KeepMax {
	deque<int> a;

	void append(int elem) {
		while (!a.empty() && a.back() < elem)
			a.pop_back();
		a.push_back(elem);
	}

	void pop(int elem) {
		if (a.front() == elem)
			a.pop_front();
	}

	int get() {
		return a.front();
	}
};


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);

	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];

	KeepMin lmin, rmin;
	KeepMax lmax, rmax;
	lmin.append(INF);
	lmax.append(0);

	for (int i = 0; i < n; ++i) {
		rmin.append(a[i]);
		rmax.append(a[i]);
	}

	for (int k = 0; k < n; ++k) {
		long double tmin = 1.0, tmax = 1.0;
		if (rmin.get() > lmin.get())
			tmin = (long double)lmin.get() / rmin.get();
		if (rmax.get() > lmax.get())
			tmax = (long double)lmax.get() / rmax.get();

		long double nspr_min = max(rmax.get() * tmin, (long double)lmax.get()) - min(rmin.get() * tmin, (long double)lmin.get());
		long double nspr_max = max(rmax.get() * tmax, (long double)lmax.get()) - min(rmin.get() * tmax, (long double)lmin.get());

		cout << setprecision(10);

		if (nspr_min < nspr_max)
			cout << 1 - tmin << " ";
		else if (nspr_max < nspr_min)
			cout << 1 - tmax << " ";
		else
			cout << 1 - min(tmax, tmin) << " ";

		lmin.append(a[k]);
		lmax.append(a[k]);
		rmin.pop(a[k]);
		rmax.pop(a[k]);
	}
}
