#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <math.h>
#include <climits>
#include <queue>
#include <algorithm>
#include <assert.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = INT_MAX;
const ld EPS = 1e-8;

bool le(const ld &a, const ld &b)
{
    return a < b - EPS;
}

bool gr(const ld &a, const ld &b)
{
    return a > b + EPS;
}

struct pb
{
    ld a, b, c;
};

struct pt
{
    ld x, y;
};

bool pt_in_pb(const pt &a, const pb &b)
{
    if (b.a > 0)
    {
        return gr(a.y, b.a * a.x * a.x + b.b * a.x + b.c);
    }
    else
    {
        return le(a.y, b.a * a.x * a.x + b.b * a.x + b.c);
    }
}

vector<pb> pbs;

int f(ld x, ld y)
{
    pt p = {x, y};
    int ans = 0;
    for (auto i : pbs)
    {
        if (pt_in_pb(p, i))
        {
            ans++;
        }
    }
    return ans;
}

const ld MINX = -1e9;
const ld MAXX = 1e9;

int main()
{
//     ios_base::sync_with_stdio(false);
//     cin.tie(0);
//     cout.tie(0);
//     cout.precision(18);
#ifdef HOME_DIDUK001
    freopen("in", "r", stdin);
//     freopen("out", "w", stdout);
#endif

    int n;
    cin >> n;

    for (int i = 0; i < n; i++)
    {
        ld a, b, c;
        cin >> a >> b >> c;
        pbs.push_back({a, b, c});
    }

    ld lx = MINX, rx = MAXX;
    while (gr(abs(lx - rx), EPS))
    {
        // cout << lx << ' ' << rx << '\n';
        ld mlx = lx + (rx - lx) / 3;
        ld mrx = lx + (rx - lx) / 3 * 2;
        // cout <<  fixed << lx << " " << rx << '\n';
        ld ly = MINX, ry = MAXX;
        while (gr(abs(ly - ry), EPS))
        {
            // ld mly = (ly + ry) / 3;
            // ld mry = (ly + ry) / 3 * 2;
            ld mly = ly + (ry - ly) / 3;
            ld mry = ly + (ry - ly) / 3 * 2;

            // cout << ly << ' ' << ry << ' ' << mly << ' ' << mry << '\n';
            int al = f(mlx, mly);
            int ar = f(mlx, mry);
            if (ar > al)
            {
                ly = mly;
            }
            else if (al > ar)
            {
                ry = mry;
            }
            else{
                ly = mly;
                ry = mry;
            }
        }
        ld ansl = f(mlx, ly);


        ly = MINX, ry = MAXX;
        while (gr(abs(ly - ry), EPS))
        {
            ld mly = ly + (ry - ly) / 3;
            ld mry = ly + (ry - ly) / 3 * 2;

            int al = f(mrx, mly);
            int ar = f(mrx, mry);
            if (ar > al)
            {
                ly = mly;
            }
            else if (al > ar)
            {
                ry = mry;
            }
            else{
                ly = mly;
                ry = mry;
            }
        }
        ld ansr = f(mrx, ly);
        if (ansr > ansl)
        {
            lx = mlx;
        }
        else if (ansl > ansr)
        {
            rx = mrx;
        } else{
            lx = mlx;
            rx = mrx;
        }
    }
    ld ansx = rx;
    // ld ansx = 0;
    ld ly = MINX, ry =  MAXX;
    while (gr(abs(ly - ry), EPS))
    {
        ld mly = ly + (ry - ly) / 3;
        ld mry = ly + (ry - ly) / 3 * 2;

        int al = f(ansx, mly);
        int ar = f(ansx, mry);
        if (ar > al)
        {
            ly = mly;
        }
        else if (al > ar)
        {
            ry = mry;
        }
        else{
            ly = mly;
            ry = mry;
        }
    }
    ld ansy = ry;
    // cout << pt_in_pb({ansx, ansy}, pbs[0]);
    cout << fixed << ansx << ' ' << ansy << '\n';
}