#include <iostream>
#include <iomanip>
#include <map>
#include <set>
#include <cmath>
#include <string>
#include <stack>
#include <algorithm>
#include <vector>

#pragma gcc-optimize ("-Ofast")
#pragma gcc-optimize ("unroll-loops")

using itn = int;
using ll = long long;

const int INF = 1e9;

const long double EPS = 1e-12;

using namespace std;

int n;

vector <long double> a, sufmin, sufmax;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    sufmin.resize(n);
    sufmax.resize(n);
    sufmin[n - 1] = a[n - 1];
    sufmax[n - 1] = a[n - 1];
    for (int i = 1; i < n; ++i){
        sufmin[n - i - 1] = min(sufmin[n - i], a[n - i - 1]);
        sufmax[n - i - 1] = max(sufmax[n - i], a[n - i - 1]);
    }
    cout << fixed << setprecision(12);
    cout << 1.0 << " ";
    long double max1 = a[0], max2, min1 = a[0], min2;
    for (int i = 1; i < n; ++i) {
        max2 = sufmax[i], min2 = sufmin[i];
        long double lft = 0, rgh = 1, mid1, mid2;
        while (rgh - lft > EPS) {
            mid1 = (2 * lft + rgh) / 3;
            mid2 = (2 * rgh + lft) / 3;
            long double ans1 = abs(max(max1, max2 * (1 - mid1)) - min(min1, min2 * (1 - mid1)));
            long double ans2 = abs(max(max1, max2 * (1 - mid2)) - min(min1, min2 * (1 - mid2)));
            if (ans1 >= ans2)
                lft = mid1;
            else
                rgh = mid2;
        }
        cout << rgh << " ";
        max1 = max(max1, a[i]);
        min1 = min(min1, a[i]);
    }
}