#include <iostream>
#include <iomanip>
#include <map>
#include <set>
#include <cmath>
#include <string>
#include <stack>
#include <algorithm>
#include <vector>
#include <bitset>

using itn = int;
using ll = long long;

const int INF = 1e9;

const long double INFD = 1e16, EPS = 1e-15;

using namespace std;

struct parabol {
    long double a, b, c;
    parabol(long double _a, long double _b, long double _c) : a(_a), b(_b), c(_c) {}
    long double y(long double x) {
        return a * x * x + b * x + c;
    }
};

int n;

vector <parabol> fir, sec;

long double miny(long double x) {
    long double ans = INFD;
    for (int i = 0; i < sec.size(); ++i)
        ans = min(ans, sec[i].y(x));
    return ans;
}

long double maxy(long double x) {
    long double ans = -INFD;
    for (int i = 0; i < fir.size(); ++i)
        ans = max(ans, fir[i].y(x));
    return ans;
}

long double func(long double x) {
    return miny(x) - maxy(x);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cin >> n;
    long double a, b, c, maxc, minc;
    for (int i = 0; i < n; ++i) {
        cin >> a >> b >> c;
        if (a > 0)
            fir.emplace_back(a, b, c);
        else
            sec.emplace_back(a, b, c);
        maxc = max(c, maxc);
        minc = min(c, minc);
    }
    if (fir.size() == 0) {
        cout << 0 << " " << minc - 1;
        return 0;
    }
    if (sec.size() == 0) {
        cout << 0 << " " << maxc + 1;
        return 0;
    }
    long double lft = -INF, rgh = INF, mid1, mid2;
    while (rgh - lft > EPS) {
        mid1 = (lft * 2 + rgh) / 3;
        mid2 = (2 * rgh + lft) / 3;
        if (func(mid1) > func(mid2))
            rgh = mid2;
        else
            lft = mid1;
    }
    long double x = (lft + rgh) / 2, y = (miny(x) + maxy(x)) / 2;
    cout << fixed << setprecision(13);
    cout << x << " " << y << "\n";
}