#include <iostream>
#include <iomanip>
#include <map>
#include <set>
#include <cmath>
#include <string>
#include <stack>
#include <algorithm>
#include <vector>
#include <bitset>

using itn = int;
using ll = long long;

const int INF = 1e9;

using namespace std;

int n, l;

vector <string> words;

vector <set <int>> exists;

vector <int> classes[2], for_sort;

char cur_r;

vector <int> r_of_class;

bool cmp(int i, int j) {
    for (int ind = 0; ind < l; ++ind) {
        if (words[i][ind] != words[j][ind] && (words[i][ind] == cur_r || words[j][ind] == cur_r))
            return words[j][ind] == cur_r;
    }
    return false;
}

int find_r(int l, int rgh) {
    for (int r = 0; r < 26; ++r) {
        bool exist = true;
        for (int i = l; i <= rgh; ++i) {
            if (exists[for_sort[i]].find(r) == exists[for_sort[i]].end()) {
                exist = false;
                break;
            }
        }
        if (exist)
            return r;
    }
    return -1;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cin >> l >> n;
    words.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> words[i];
    exists.resize(n);
    for (char r = 'a'; r <= 'z'; ++r) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < l; ++j) {
                if (words[i][j] == r) {
                    exists[i].insert(r - 'a');
                    break;
                }
            }
        }
    }
    for_sort.resize(n);
    for (int i = 0; i < n; ++i)
        for_sort[i] = i;
    classes[0].resize(n);
    classes[1].resize(n);
    r_of_class.resize(n);
    int cclass = 0;
    while (classes[cclass][n - 1] != n - 1){
        int ind1 = 0;
        for (int i = 1; i <= n; ++i) {
            if (i == n || classes[cclass][i] != classes[cclass][i - 1]) {
                if (ind1 == i - 1) {
                    ind1 = i;
                    continue;
                }
                int r = find_r(ind1, i - 1);
                if (r == -1) {
                    cout << "NO";
                    return 0;
                }
                cur_r = 'a' + r;
                sort(for_sort.begin() + ind1, for_sort.begin() + i, cmp);
                for (int j = ind1; j < i; ++j)
                    exists[for_sort[j]].erase(r);
                ind1 = i;
                r_of_class[classes[cclass][i - 1]] = r;
            }
        }
        int curind = 0;
        for (int i = 1; i < n; ++i) {
            if (classes[cclass][i] != classes[cclass][i - 1]) {
                ++curind;
            }
            else {
                cur_r = 'a' + r_of_class[classes[cclass][i - 1]];
                if (cmp(for_sort[i - 1], for_sort[i]))
                    ++curind;
            }
            classes[(cclass + 1) % 2][i] = curind;
        }
        cclass = 1 - cclass;
    }
    cout << "YES";
}