#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <deque>
#include <algorithm>
#include <random>
#include <cmath>
#include <ctime>
#include <string>
#include <queue>
#include <iomanip>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

struct parabola
{
    ld a, b, c;
    ld f(ld x)
    {
        return a * x * x + b * x + c;
    }
};

ll n;
vector < parabola > v;

void check(ll x)
{
    ld up = 1e18, down = -1e18;
    for (ll i = 0; i < n; i++)
    {
        if (v[i].a < 0)
        {
            up = min(up, v[i].f(x));
        }
        else
        {
            down = max(down, v[i].f(x));
        }
    }
    if (up > down)
    {
        cout << x << ' ' << (up + down) / 2;
        exit(0);
    }
    //cout << up << ' ' << down << ' ' << x << " check\n";
}

void solve() 
{
    cin >> n;
    v.resize(n);
    vector < ld > top(n);
    for (ll i = 0; i < n; i++)
    {
        ll a, b, c;
        cin >> a >> b >> c;
        v[i] = { (ld)a, (ld)b, (ld)c };
        top[i] = -b / (2 * a);
    }
    sort(top.begin(), top.end());
    ld l = -1e18, r = 1e18;
    ll k = 10000;
    while (k--)
    {
        ld m = (r + l) / 2;
        check(m);
        //cout << l << ' ' << m << ' ' << r << "\n";
        ll lb = lower_bound(top.begin(), top.end(), m) - top.begin();
        ll ub = top.end() - upper_bound(top.begin(), top.end(), m);
        if (lb > ub)
            r = m;
        else l = m;
    }
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0);
    cout << fixed << setprecision(10);
    int tt = 1;
    //cin>>tt;
    while (tt--)
        solve();
}