#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<queue>
#include<deque>
#include<random>
#include<fstream>
#include<cmath>
#include<iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;

ll bin_pow(ll a, ll step)
{
	if (step == 0)
		return 1;
	if (step % 2 == 1)
		return a*bin_pow(a, step-1);
	ll now = bin_pow(a, step / 2);
	return now * now;
}

ld eps = 1e-12;

void solveG() {
	vector<int>p = { 0, 1, 2, 3 }, ans_p;
	vector<ld>arr(4), ans;
	for (auto&i : arr)
		cin >> i;
	ld best_ans = -1;
	do {
		ld l = 0, r = 1e9;
		for (int i = 0; i < 600; i++) {
			ld m = (l + r) / 2;
			ld a1 = arr[p[0]], a2 = m / (a1 - 1) + 1, a3 = arr[p[2]], a4 = m / (a3 - 1) + 1;
			if (a2 - arr[p[1]] <= eps && a4 - arr[p[3]] <= eps)
				l = m;
			else
				r = m;
		}
		if (l - best_ans >= eps) {
			ans_p = p;
			ld a1 = arr[p[0]], a2 = l / (a1 - 1) + 1, a3 = arr[p[2]], a4 = l / (a3 - 1) + 1;
			ans = { a1, a4, a3, a2 };
		}
	} while (!next_permutation(p.begin(), p.end()));
	for (auto i : p)
		cout << i + 1 << ' ';
	cout << '\n' << setprecision(7) << fixed;
	for (auto&i : ans)
		cout << i << ' ';
}

void solveE() {
	int n; cin >> n;
	vector<ll>arr(n);
	vector<ll>prefmx(n, -1), prefmn(n, 1e9+10), sufmn(n), sufmx(n);
	for (auto&i : arr) {
		cin >> i;
	}
	//prefmx[0] = prefmn[0] = arr[0];
	sufmx[n - 1] = sufmn[n - 1] = arr[n - 1];
	for (int i = 1; i < n; i++) {
		prefmx[i] = max(prefmx[i - 1], arr[i - 1]);
		prefmn[i] = min(prefmn[i - 1], arr[i - 1]);
	}
	for (int i = n- 2; i >= 0; i--) {
		sufmx[i] = max(sufmx[i + 1], arr[i]);
		sufmn[i] = min(sufmn[i + 1], arr[i]);
	}
	for (int k = 0; k < n; k++) {
		ld mn_pref = 1e9 + 1, mx_pref = -1, mn_suf = 1e9 + 1, mx_suf = -1;
		if (k != 0) {
			mn_pref = prefmn[k];
				mx_pref = prefmx[k];
		}
		mn_suf = sufmn[k];
		mx_suf = sufmx[k];
		ld l = 0, r = 1.0000000000001;
		while(r - l >= eps){
			ld m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
			ld x1 = max(mx_pref, mx_suf * (1 - m1)) - min(mn_pref, mn_suf * (1 - m1)), x2 = max(mx_pref, mx_suf * (1 - m2)) - min(mn_pref, mn_suf * (1 - m2));
			if (abs(x1 - x2) <= eps)
				l = m1; 
			else {
				if (x1 <= x2)
					r = m2;
				else
					l = m1;
			}
		}
		cout << setprecision(15) << fixed << r << ' ';
	}
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	//cin>>t;
	while (t--) {
		solveE();
	}
	return 0;
}