#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<queue>
#include<deque>
#include<random>
#include <bitset>
#include<fstream>
#include<stack>
#include<cmath>
#include<iomanip>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;

ll bin_pow(ll a, ll step)
{
	if (step == 0)
		return 1;
	if (step % 2 == 1)
		return a*bin_pow(a, step-1);
	ll now = bin_pow(a, step / 2);
	return now * now;
}

ld eps = 1e-12;

void solveG() {
	vector<int>p = { 0, 1, 2, 3 }, ans_p(4);
	vector<ld>arr(4), ans;
	for (auto&i : arr)
		cin >> i;
	ld best_ans = -1;
	while (next_permutation(p.begin(), p.end())) {
		ld l = 0, r = 100;
		for (int i = 0; i < 600; i++) {
			ld m = (l + r) / 2;
			ld a1 = arr[p[0]], a2, a3 = arr[p[2]], a4;
			if ((a1 == 1 || a3 == 1) && m > eps)
			{
				r = 0;
				continue;
			}
			if (a1 == 1)
				a2 = arr[p[1]];
			else
				a2 = m / (a1 - 1) + 1;
			if (a3 == 1)
				a4 = arr[p[3]];
			else
				a4 = m / (a3 - 1) + 1;
			if (a2 - arr[p[1]] <= eps && a4 - arr[p[3]] <= eps)
				l = m;
			else
				r = m;
		}
		if (l - best_ans >= eps) {
			ans_p[0] = p[0];
			ans_p[1] = p[3];
			ans_p[2] = p[2];
			ans_p[3] = p[1];
			ld a1 = arr[p[0]], a3 = arr[p[2]];
			ld a2, a4;
			if (a1 == 1)
				a2 = arr[p[1]];
			else
				a2 = l / (a1 - 1) + 1;
			if (a3 == 1)
				a4 = arr[p[3]];
			else
				a4 = l / (a3 - 1) + 1;
			ans = { a1, a4, a3, a2 };
			best_ans = l;
		}
	} 
	for (auto i : ans_p)
		cout << i + 1 << ' ';
	cout << '\n' << setprecision(7) << fixed;
	for (auto&i : ans)
		cout << i << ' ';
}

vector<string>arr;
ll p1 = 237, p2 = 239, mod1 = 2286661337, mod2 = 1e9 + 7;

bool brute(ll mask, vector<int>a) {
	if (a.size() == 1)
		return 1;
	vector<set<int>>cnt(26);
	for (auto i : a) {
		for (auto j : arr[i])
			cnt[j - 'a'].insert(i);
	}
	for (int i = 0; i < 26; i++) {
		if ((mask & (1 << i)) == 0 && cnt[i].size() == a.size()) {
			map<pair<ll, ll>, vector<int>>ans;
			for (auto ind:a) {
				ll h1 = 0, h2 = 0;
				for (int j = 0; j < arr[ind].size(); j++) {
					h1 = (h1 * p1 % mod1 + (arr[ind][j] - 'a' == i)) % mod1;
					h2 = (h2 * p2 % mod2 + (arr[ind][j] - 'a' == i)) % mod2;
				}
				ans[{h1, h2}].push_back(ind);
			}
			mask |= (1 << i);
			bool r = 1;
			for (auto&el : ans) {
				r &= brute(mask, el.second);
			}
			return r;
		}
	}
	return 0;
}

void solveI() {
	int L, n;
	cin >> L >> n;
	arr.resize(n);
	for (auto&i : arr)
		cin >> i;
	vector<int>p(n);
	for (int i = 0; i < n; i++)
		p[i] = i;
	if (brute(0, p))
		cout << "YES";
	else
		cout << "NO";
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	//cin>>t;
	while (t--) {
		solveI();
	}
	return 0;
}