#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<queue>
#include<deque>
#include<random>
#include<fstream>
#include<stack>
#include<cmath>
#include<iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;

ll bin_pow(ll a, ll step)
{
	if (step == 0)
		return 1;
	if (step % 2 == 1)
		return a*bin_pow(a, step-1);
	ll now = bin_pow(a, step / 2);
	return now * now;
}

ld eps = 1e-12;

void solveG() {
	vector<int>p = { 0, 1, 2, 3 }, ans_p;
	vector<ld>arr(4), ans;
	for (auto&i : arr)
		cin >> i;
	ld best_ans = -1;
	do {
		ld l = 0, r = 1e9;
		for (int i = 0; i < 600; i++) {
			ld m = (l + r) / 2;
			ld a1 = arr[p[0]], a2 = m / (a1 - 1) + 1, a3 = arr[p[2]], a4 = m / (a3 - 1) + 1;
			if (a2 - arr[p[1]] <= eps && a4 - arr[p[3]] <= eps)
				l = m;
			else
				r = m;
		}
		if (l - best_ans >= eps) {
			ans_p = p;
			ld a1 = arr[p[0]], a2 = l / (a1 - 1) + 1, a3 = arr[p[2]], a4 = l / (a3 - 1) + 1;
			ans = { a1, a4, a3, a2 };
		}
	} while (!next_permutation(p.begin(), p.end()));
	for (auto i : p)
		cout << i + 1 << ' ';
	cout << '\n' << setprecision(7) << fixed;
	for (auto&i : ans)
		cout << i << ' ';
}

void solveK() {
	stack<int>a, b;
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		int q;
		cin >> q;
		if (!a.empty())
		{
			while (a.top() > q)
			{
				b.push(a.top());
				a.pop();
				cout << "21\n";
				if (a.empty())
					break;
			}
		}
		if (!b.empty())
		{
			while (b.top() < q)
			{
				a.push(b.top());
				b.pop();
				cout << "12\n";
				if (b.empty())
					break;
			}
		}
		b.push(q);
		cout << "1\n";
	}
	while (!a.empty())
	{
		b.push(a.top());
		a.pop();
		cout << "21\n";
	}
	while (!b.empty())
	{
		cout << "-1\n";
		b.pop();
	}

}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	//cin>>t;
	while (t--) {
		solveK();
	}
	return 0;
}