#include <bits/stdc++.h>

using namespace std;

const double EPS = 1e-9;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    long long n; cin >> n;

    vector<long long> a(n), prefMax(n), prefMin(n), suffMax(n), suffMin(n);

    for(long long i = 0; i < n; i++) {
        cin >> a[i];
    }

    prefMax[0] = prefMin[0] = a[0];
    for(long long i = 1; i < n; i++) {
        prefMax[i] = max(prefMax[i - 1], a[i]);
        prefMin[i] = min(prefMin[i - 1], a[i]);
    }

    suffMax[n - 1] = suffMin[n - 1] = a[n - 1];
    for(long long i = n - 2; i >= 0; i--) {
        suffMax[i] = max(suffMax[i + 1], a[i]);
        suffMin[i] = min(suffMin[i + 1], a[i]);
    }

    vector<double> ans(n);

    ans[0] = 1.0;
    for(long long i = 1; i < n; i++) {
        double low = 0, high = 1, cur = -1;
        auto f = [&](long long i, double t) {
            return max(prefMax[i - 1] * 1.0, suffMax[i] * (1.0 - t)) - min(prefMin[i - 1] * 1.0, suffMin[i] * (1.0 - t));
        };
        while(high - low >= EPS) {
            double m1 = low + (high - low) / 3.0;
            double m2 = high - (high - low) / 3.0;
            if(f(i, m1) < f(i, m2)) {
                high = m2;
                cur = m2;
            }
            else {
                low = m1;
                cur = m1;
            }
        }
        ans[i] = cur;
    }

    for(long long i = 0; i < n; i++) {
        cout << fixed << setprecision(11) << ans[i] << " ";
    }

    return 0;
}
