#include <bits/stdc++.h>

#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.begin(), x.rend()
#define ckmin(a, b) a = min(a, b)
#define ckmax(a, b) a = max(a, b)
#define int long long

using namespace std;

const int mod = 1e9 + 7;
const int maxn = 5e5;
int t[maxn * 4];
vector<int> rz;
const int inf = 1e18;

void build(int v, int tl, int tr) {
    if (tl == tr) {
        t[v] = rz[tl];
    } else {
        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm);
        build(v * 2 + 1, tm + 1, tr);
        t[v] = min(t[v * 2], t[v * 2 + 1]);
    }
}

int get(int v, int tl, int tr, int l, int r) {
    if (tl > r || tr < l)return inf;
    if (l <= tl && tr <= r) {
        return t[v];
    }
    int tm = (tl + tr) / 2;
    return min(get(v * 2, tl, tm, l, r), get(v * 2 + 1, tm + 1, tr, l, r));
}

vector<int> lai_left(vector<int> a) {
    vector<int> st;
    vector<int> ans(a.size());
    for (int i = 0; i < a.size(); ++i) {
        while (st.size() > 0 && a[st.back()] >= a[i]) {
            st.pop_back();
        }
        if (st.size() == 0) {
            ans[i] = -1;
        } else {
            ans[i] = st.back();
        }
        st.push_back(i);
    }
    return ans;
}

vector<int> lai_right(vector<int> a) {
    vector<int> st;
    vector<int> ans(a.size());
    for (int i = a.size() - 1; i >= 0; --i) {
        while (st.size() > 0 && a[st.back()] > a[i]) {
            st.pop_back();
        }
        if (st.size() == 0) {
            ans[i] = a.size();
        } else {
            ans[i] = st.back();
        }
        st.push_back(i);
    }
    return ans;
}

int calc(vector<int> mn, vector<int> sums) {
    int n = mn.size();
    if (mn.size() == 0)return 0;
    vector<int> left = lai_left(mn);
    vector<int> right = lai_right(mn);
    int sum = 0;
    vector<int> pref(n + 1);
    pref[0] = 0;
    for (int i = 1; i < n + 1; ++i) {
        pref[i] = pref[i - 1] + sums[i - 1];
    }
    for (int i = 0; i < mn.size(); ++i) {
        int l = left[i] + 1;
        int r = right[i] - 1;
        if (mn[i] == inf) {
            sum += (pref[i + 1] - pref[l]) * (r - i + 1) + (pref[r + 1] - pref[i]) * (i - l + 1);
        } else {
            sum += mn[i] * (i - l + 1) * (r - i + 1);
        }
        sum %= mod;
    }
    return sum;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, k;
    cin >> n >> k;
    vector<pair<int, int>> a(n);
    int pref[n + 1];
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
        if (a[i].first < a[i].second) {
            swap(a[i].first, a[i].second);
        }
        rz.push_back(a[i].first - a[i].second);
        if (rz.back() % k == 0)rz.back() = inf;
    }
    build(1, 0, n - 1);
    pref[0] = 0;
    for (int i = 1; i <= n; ++i) {
        pref[i] = (pref[i - 1] + a[i - 1].first);
    }
    map<int, vector<int>> pos;
    for (int i = 0; i <= n; ++i) {
        pos[pref[i] % k].push_back(i);
    }
    int ans = 0;
    for (int i = 0; i < a.size(); ++i) {
        ans += a[i].first * (i + 1) * (a.size() - i);
        ans %= mod;
    }
    for (auto x: pos) {
        vector<int> b = x.second;
        vector<int> sums(b.size() - 1);
        vector<int> mn(b.size() - 1);
        for (int i = 0; i < b.size() - 1; ++i) {
            sums[i] = pref[b[i + 1]] - pref[b[i]];
            mn[i] = get(1, 0, n - 1, b[i], b[i + 1] - 1);
        }
        ans -= calc(mn, sums);
        ans %= mod;
    }
    cout << (ans + mod) % mod;
}