#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vsi = vector<set<ll>>;
using vmsi = vector<multiset<ll>>;


#ifndef DEBUG
#define endl '\n'
#endif


template<typename T, typename V>
istream &operator>>(istream &is, pair<T, V> &p) {
    is >> p.first >> p.second;
    return is;
}


template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (auto &e: v) is >> e;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &e: v) os << e << ' ';
    return os;
}

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(30);
    cout.setf(ios::fixed);

    solve();
}

// ----------------

void solve() {
    ll n;
    cin >> n;
    vi a1(n), b1(n);
    cin >> a1 >> b1;

    auto check = [a1, b1, n](ll k) -> bool {
        vi a = a1;
        vi b = b1;
        vi c(n);
        ll z = 0, ov = 0;
        for (ll i = 0; i < n; ++i) {
            assert(c[i] <= b[i]);
            if (a[i] + c[i] > b[i]) {
                for (ll j = max(ov, i + 1); j <= min(i + k, n - 1); ++j) {
                    ll t = a[i] + c[i] - b[i];
                    ll p = b[j] - c[j];
                    if (t >= p) {
                        ov = j + 1;
                        c[j] += p;
                        a[i] -= p;
                    } else {
                        c[j] += t;
                        a[i] -= t;
                        break;
                    }
                }
                if (a[i] + c[i] > b[i])
                    return false;
            } else if (a[i] + c[i] < b[i]) {
                for (ll j = max(z, i + 1); j <= min(i + k, n - 1); ++j) {
                    ll t = b[i] - (a[i] + c[i]);
                    ll p = a[j];
                    if (t >= p) {
                        z = j + 1;
                        a[j] -= p;
                        c[i] += p;
                    } else {
                        a[j] -= t;
                        c[i] += t;
                        break;
                    }
                }
            }
        }
        return true;
    };

    ll L = -1, R = n + 10;
    while (R - L > 1) {
        ll M = (L + R) / 2;
        (check(M) ? R : L) = M;
    }
    cout << (R > n + 5 ? -1 : R) << endl;
}
