#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = int_fast64_t;
using ull = uint_fast64_t;

#define int ll
#define len(a) (int)(a).size()
#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()


const int INF = 1 << 29;
const ll INFll = 1ll << 62;

template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (T &o: v)
        is >> o;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (T &o: v)
        os << o;
    return os;
}


const int k = 'z' - 'a' + 1;

struct word{
    unordered_map<char, vector<int>> positions;
    bitset<k> letters;
    vector<bool> known;
    string s;

    bool operator==(const word& o) const {
        assert(o.s.size() == s.size());
        for (int i = 0; i < len(s); ++i) {
            if(known[i] != o.known[i])
                return false;
            if(known[i] && s[i] != o.s[i])
                return false;
        }
        return true;
    }

    bool operator!=(const word &rhs) const {
        return !(rhs == *this);
    }

    bool operator<(const word& o) const {
        assert(o.s.size() == s.size());
        for (int i = 0; i < len(s); ++i) {
            if(known[i] && !o.known[i])
                return false;
            if(!known[i] && o.known[i])
                return true;
            if(known[i] && o.known[i] && s[i] != o.s[i])
                return s[i] < o.s[i];
        }
        return false;
    }
};

int l, n;
vector<word> w;

void check(int begin, int end){
    if(end - begin == 1)
        return;
    bitset<k> cletters = w[begin].letters;
    for (int i = begin + 1; i < end; ++i) {
        cletters &= w[i].letters;
    }
    if(cletters.none()){
        cout << "NO";
        exit(0);
    }
    for (int i = begin; i < end; ++i) {
        for(int bit = cletters._Find_first(); bit < len(cletters); bit = cletters._Find_next(bit)){
            for(int pos : w[i].positions['a' + bit]){
                w[i].known[pos] = true;
            }
            w[i].letters[bit] = false;
        }
    }
    sort(w.begin() + begin, w.begin() + end);
    int prev_begin = begin;
    for (int i = begin + 1; i < end; ++i) {
        if(w[i - 1] != w[i]){
            check(prev_begin, i);
            prev_begin = i;
        }
    }
    check(prev_begin, end);
}


void solve() {
    cin >> l >> n;
    w.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i].s;
        w[i].known.resize(len(w[i].s));
        for (int j = 0; j < l; ++j) {
            w[i].positions[w[i].s[j]].push_back(j);
            w[i].letters[w[i].s[j] - 'a'] = true;
        }
    }
    check(0, n);
    cout << "YES";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}
