#include <iostream>
#include <iomanip>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll N = 2 * 1e5;
const ld EPS = 0.000000001;

vector<ll>t(4 * N), t2(4 * N), a(N);
ll n;

void build(ll tv, ll tl, ll tr, vector<ll>&a) {
	if (tl == tr) {
		t[tv] = a[tl];
		return;
	}
	ll tm = (tl + tr) / 2;
	build(2 * tv + 1, tl, tm, a);
	build(2 * tv + 2, tm + 1, tr, a);
	t[tv] = max(t[2 * tv + 1], t[2 * tv + 2]);
}

void build2(ll tv, ll tl, ll tr, vector<ll>&a) {
	if (tl == tr) {
		t2[tv] = a[tl];
		return;
	}
	ll tm = (tl + tr) / 2;
	build2(2 * tv + 1, tl, tm, a);
	build2(2 * tv + 2, tm + 1, tr, a);
	t2[tv] = min(t2[2 * tv + 1], t2[2 * tv + 2]);
}

ll get_max(ll v, ll vl, ll vr, ll l, ll r) {
	if (l > vr || r < vl)
		return 0;
	if (l <= vl && r >= vr)
		return t[v];
	ll m = (vl + vr) / 2;
	ll m1 = get_max(2 * v + 1, vl, m, l, r);
	ll m2 = get_max(2 * v + 2, m + 1, vr, l, r);
	return max(m1, m2);
}

ll get_min(ll v, ll vl, ll vr, ll l, ll r) {
	if (l > vr || r < vl)
		return 1e18;
	if (l <= vl && r >= vr)
		return t2[v];
	ll m = (vl + vr) / 2;
	ll m1 = get_min(2 * v + 1, vl, m, l, r);
	ll m2 = get_min(2 * v + 2, m + 1, vr, l, r);
	return min(m1, m2);
}

ld f(ld v, ll k) {
	//cout << v << " " << k << " : ";
	ll mn = get_min(0, 0, n - 1, k, n - 1), mx = get_max(0, 0, n - 1, k, n - 1);
	ll mn1 = get_min(0, 0, n - 1, 0, k - 1), mx1 = get_max(0, 0, n - 1, 0, k - 1);
	if (k == 0) 
		return (ld)mx * (ld)((ld)1 - v) - (ld)mn * (ld)((ld)1 - v);
	//cout << mn << endl << mn1 << endl << mx << endl << mx1 << endl;
	return (ld)max((ld)mx * (ld)((ld)1 - v), (ld)mx1) - (ld)min((ld)mn * (ld)((ld)1 - v), (ld)mn1);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n;
	for (int i = 0; i < n; i++)
		cin >> a[i];
	build(0, 0, n - 1, a);
	build2(0, 0, n - 1, a);
	for (int i = 0; i < n; i++) {
		ld l = 0, r = 1;
		while (r - l > EPS) {
			ld m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
			//cout << m1 << " " << m2 << endl;
			if (f(m1, i) < f(m2, i))
				r = m2;
			else
				l = m1;
		}
		if (f(l, i) < f(r, i))
			cout << fixed << setprecision(9) << l << endl;
		else 
			cout << fixed << setprecision(9) << r << endl;
	}
}