#include <iostream>
#include <deque>
using namespace std;

#define ld long double

ld min(ld a, ld b)
{
	return a > b ? b : a;
}

ld max(ld a, ld b)
{
	return a > b ? a : b;
}

class MinMaxStack
{
	int len;
	ld* items;
	ld* mins, *maxs;
	int i;
public:
	MinMaxStack(int len)
	{
		this->len = len;
		items = new ld[len];
		mins = new ld[len];
		maxs = new ld[len];
		i = -1;
	}
	void Add(ld item)
	{
		i++;
		items[i] = item;
		if (i == 0)
		{
			maxs[0] = item;
			mins[0] = item;
		}
		else
		{
			maxs[i] = maxs[i - 1] > item ? maxs[i - 1] : item;
			mins[i] = mins[i - 1] < item ? mins[i - 1] : item;
		}
	}
	ld Top()
	{
		return items[i];
	}
	ld Min()
	{
		return mins[i];
	}
	ld Max()
	{
		return maxs[i];
	}
	void Pop()
	{
		i--;
	}
	~MinMaxStack()
	{
		delete items;
		delete mins;
		delete maxs;
	}
};

int main()
{
	int n;
	cin >> n;
	ld* a = new ld[n];
	for (int i = 0; i < n; i++)
		cin >> a[i];
	ld minleft = a[0], maxleft = a[0];
	MinMaxStack right = MinMaxStack(n - 1);
	for (int i = n - 1; i > 0; i--)
		right.Add(a[i]);
	cout << "1.00 ";
	cout.precision(11);
	for (int k = 1; k < n; k++)
	{
		ld bestinequity = INFINITY;
		ld bestk = -1;
		if (right.Min() > maxleft)
		{
			ld inversek = maxleft / right.Min();
			ld inequity = max(maxleft, right.Max() * inversek) - min(minleft, right.Min() * inversek);
			if (inequity < bestinequity)
			{
				bestinequity = inequity;
				bestk = 1 - inversek;
			}
		}
		if (right.Min() > minleft)
		{
			ld inversek = minleft / right.Min();
			ld inequity = max(right.Max() * inversek, maxleft) - min(minleft, right.Min() * inversek);
			if (inequity < bestinequity)
			{
				bestinequity = inequity;
				bestk = 1 - inversek;
			}
		}
		if (right.Max() > maxleft)
		{
			ld inversek = maxleft / right.Max();
			ld inequity = max(maxleft, right.Max() * inversek) - min(minleft, right.Min() * inversek);
			if (inequity < bestinequity)
			{
				bestinequity = inequity;
				bestk = 1 - inversek;
			}
		}
		if (right.Max() > minleft)
		{
			ld inversek = minleft / right.Max();
			ld inequity = max(maxleft, right.Max() * inversek) - min(minleft, right.Min() * inversek);
			if (inequity < bestinequity)
			{
				bestinequity = inequity;
				bestk = 1 - inversek;
			}
		}
		if (maxleft < bestinequity)
		{
			bestinequity = maxleft;
			bestk = 1;
		}
		{
			ld inequity = max(maxleft, right.Max()) - min(minleft, right.Min());
			if (inequity < bestinequity)
				bestk = 0;
		}
		cout << bestk << " ";

		int top = right.Top();
		if (top < minleft)
			minleft = top;
		else if (top > maxleft)
			maxleft = top;
		right.Pop();
	}
}
