#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
constexpr ld EPS = 1e-9;

template<class T>
using V = vector<T>;
template<class T>
using VV = V<V<T>>;

using VLL = V<ll>;
using VVLL = VV<ll>;
using VB = V<char>;
using VI = V<int>;

#define FOR(i, n) for(ll i = 0; i < n; ++i)
#define ALL(a) begin(a), end(a)

bool test(VLL const& a, VLL b, ll m)
{
    ll n = a.size();
    VLL nxt(n);
    iota(ALL(nxt), 0LL);

    function<ll(ll)> get = [&](ll i)
    {
        if(i == n)
            return n;

        if(nxt[i] != i)
            return nxt[i] = get(nxt[i]);
        else if(b[i] == 0)
            return nxt[i] = get(i + 1);
        return i;
    };

    for(ll i = 0; i < n; ++i)
    {
        ll p = a[i];
        while(p)
        {
            ll j = get(max(i - m, 0LL));
            if(j == n || j > i + m)
                return false;

            ll t = min(p, b[j]);
            b[j] -= t;
            p -= t;
        }
    }

    return true;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n;
    cin >> n;

    VLL a(n);
    for(auto& i : a)
        cin >> i;

    VLL b(n);
    for(auto& i : b)
        cin >> i;

    ll l = -1, r = n + 1; //(l, r]
    while(r - l > 1)
    {
        ll m = (l + r) / 2;
        if(test(a, b, m))
            r = m;
        else
            l = m;
    }

    if(r == n + 1)
        r = -1;
    cout << r << "\n";
}
