#include <bits/stdc++.h>

using namespace std;

struct node {
    vector<int> p;
    vector<long double> vals;

    long double calc() {
        return vals[0] * vals[3] + vals[1] + vals[2];
    }
};


typedef long long ll;
typedef long double ld;
const ld eps=3e-7;

ld calc(ld a,ld b,ld c,ld d)
{
    return a*d+c+b;
}

void fix(ld mas[])
{
    ld c1=calc(mas[1],mas[2],mas[3],mas[4]);
    ld c2=calc(mas[2],mas[1],mas[4],mas[3]);
    ld t,v1,v2;
    if(abs(c1-c2)<eps)
        return ;
    if(c1>c2)
    {
        t=(mas[2]-1)*(mas[3]-1)/(mas[4]-1)+1;
        v1=calc(t,mas[2],mas[3],mas[4]);
        t=(mas[2]-1)*(mas[3]-1)/(mas[1]-1)+1;
        v2=calc(mas[1],mas[2],mas[3],t);
        if(v1>v2)
            mas[1]=(mas[2]-1)*(mas[3]-1)/(mas[4]-1)+1;
        else
            mas[4]=t;
    }
    else
    {
        t=(mas[1]-1)*(mas[4]-1)/(mas[3]-1)+1;
        v1=calc(mas[1],t,mas[3],mas[4]);
        t=(mas[1]-1)*(mas[4]-1)/(mas[2]-1)+1;
        v2=calc(mas[1],mas[2],t,mas[4]);
        if(v1>v2)
            mas[2]=(mas[1]-1)*(mas[4]-1)/(mas[3]-1)+1;
        else
            mas[3]=t;
    }
    return ;
}

node solveNew(int vals[]) {
    int ansi[5]={0},curi[5]={0},st[5]={0};
    long double ans[5]={0};
    long double cur[5]={0};
    for(int i=1;i<5;i++)
    {
        curi[i]=i;
        st[i] = vals[i - 1];
    }
    do
    {
        for(int i=1;i<5;i++)
            cur[i]=st[curi[i]];
        fix(cur);
        if(ansi[1]==0)
        {
            for(int i=1;i<5;i++)
                ansi[i]=curi[i];
            for(int i=1;i<5;i++)
                ans[i]=cur[i];
            continue;
        }
        if(calc(ans[1],ans[2],ans[3],ans[4])<calc(cur[1],cur[2],cur[3],cur[4]))
        {
            for(int i=1;i<5;i++)
                ansi[i]=curi[i];
            for(int i=1;i<5;i++)
                ans[i]=cur[i];
        }
    }while(next_permutation(curi+1,curi+5));
    node res;
    res.p = {ansi[1], ansi[2], ansi[3], ansi[4]};
    res.vals = {ans[1], ans[2], ans[3], ans[4]};
    return res;
}

node solveOld(int vals[]) {
    vector<pair<int, int>> t(4); // {index, val}
    for (int i = 0; i < 4; ++i) {
        t[i].first = i + 1;
        t[i].second = vals[i];
    }
    node res;
    res.p = {0, 1, 2, 3};
    res.vals = {0, 0, 0, 0};
    const long double EPS = 0.00000001;
    while (true) {
        vector<long double> a;
        vector<int> indexes;
        for (auto [ind, val] : t) {
            a.push_back(val);
            indexes.push_back(ind);
        }
        long double left = a[0] * a[3] - a[0] - a[3];
        long double right = a[1] * a[2] - a[1] - a[2];
        if (abs(left - right) < EPS) {
            node first;
            first.p = indexes;
            first.vals = a;
            if (first.calc() > res.calc()) {
                res = first;
            }
        } else if (left > right) {
            node first;
            first.p = indexes;
            first.vals = {(a[1] - 1) * (a[2] - 1) / (a[3] - 1) + 1, a[1], a[2], a[3]};
            if (first.calc() > res.calc()) {
                res = first;
            }
            node second;
            second.p = indexes;
            second.vals = {a[0], a[1], a[2], (a[1] - 1) * (a[2] - 1) / (a[0] - 1) + 1};
            if (second.calc() > res.calc()) {
                res = second;
            }
        } else {
            node first;
            first.p = indexes;
            first.vals = {a[0], (a[0] - 1) * (a[3] - 1) / (a[2] - 1) + 1, a[2], a[3]};
            if (first.calc() > res.calc()) {
                res = first;
            }
            node second;
            second.p = indexes;
            second.vals = {a[0], a[1], (a[0] - 1) * (a[3] - 1) / (a[1] - 1) + 1, a[3]};
            if (second.calc() > res.calc()) {
                res = second;
            }
        }
        if (!next_permutation(t.begin(), t.end())) {
            break;
        }
    }
    return res;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int vals[4];
    for (int i = 0; i < 4; ++i) {
        cin >> vals[i];
    }
    node res1 = solveNew(vals);
    node res2 = solveOld(vals);
    node ans;
    if (true) {
        ans = res1;
    } else {
        ans = res2;
    }
    for (auto i : ans.p) {
        cout << i << ' ';
    }
    cout << '\n';
    cout << fixed << setprecision(7);
    for (auto i : ans.vals) {
        cout << i << ' ';
    }
    return 0;

}
