#pragma GCC optimize("O3")

#include<bits/stdc++.h>
#define f first
#define s second
#define fi first
#define se second
#define _ << ' '  <<

#define sz(v) (int) v.size()

typedef long long ll;

using namespace std;

typedef pair<int, int> pii;

const int MOD = 1e9 + 7, P = 31;

int add(int x, int y) {
    return x + y >= MOD ? x + y - MOD : x + y;
}

int sub(int x, int y) {
    return x - y < 0 ? x - y + MOD : x - y;
}

int mul(int x, int y) {
    return 1ll * x * y % MOD;
}

int deg(int x, int y) {
    int res = 1;
    for (int z = x; y; y >>= 1, z = mul(z, z)) {
        if (y & 1) {
            res = mul(res, z);
        }
    }
    return res;
}

int inv(int x) {
    return deg(x, MOD - 2);
}

const int N = 1e6 + 5, C = 1e6 + 5;

int p[C], rp[C];

void precalc() {
    p[0] = 1;
    for (int i = 1; i < C; ++i) {
        p[i] = mul(p[i - 1], P);
    }
    rp[C - 1] = inv(p[C - 1]);
    for (int i = C - 2; ~i; --i) {
        rp[i] = mul(rp[i + 1], P);
    }
}

int n, q, m;
int a[C], b[C], h[C], ptr = 0;
pii borders[N];

inline int getHash(int L, int R) {
    if (L > R) {
        return 0;
    }
    return mul(rp[L], sub(h[R], L ? h[L - 1] : 0));
}

inline bool cmpOrder(int i, int j) {
    pii A = borders[i], B = borders[j];
    int lenA = A.se - A.fi + 1, lenB = B.se - B.fi + 1;
    int lef = 0, rig = min(lenA, lenB) + 1;
    while (lef + 1 < rig) {
        int mid = (lef + rig) / 2;
        if (getHash(A.fi, A.fi + mid - 1) == getHash(B.fi, B.fi + mid - 1)) {
            lef = mid;
        } else {
            rig = mid;
        }
    }
    if (lef == lenB) {
        return false;
    }
    if (lef == lenA) {
        return true;
    }
    return b[A.fi + lef] < b[B.fi + lef];
}

int sum[C * 4], psum[C * 4], value[C * 4];

void build(int v, int tl, int tr) {
    if (tl + 1 == tr) {
        sum[v] = mul(p[tl], a[tl]);
        psum[v] = p[tl];
        return;
    }
    int tm = (tl + tr) / 2;
    build(v * 2 + 1, tl, tm);
    build(v * 2 + 2, tm, tr);
    sum[v] = add(sum[v * 2 + 1], sum[v * 2 + 2]);
    psum[v] = add(psum[v * 2 + 1], psum[v * 2 + 2]);
}

inline void upd(int v, int x) {
    value[v] = x;
    sum[v] = mul(psum[v], value[v]);
}

inline void push(int v) {
    if (value[v]) {
        upd(v * 2 + 1, value[v]);
        upd(v * 2 + 2, value[v]);
    }
    value[v] = 0;
}

void update(int v, int tl, int tr, int L, int R, int x) {
    if (tl >= R || L >= tr) {
        return;
    }
    if (L <= tl && tr <= R) {
        upd(v, x);
        return;
    }
    push(v);
    int tm = (tl + tr) / 2;
    update(v * 2 + 1, tl, tm, L, R, x);
    update(v * 2 + 2, tm, tr, L, R, x);
    sum[v] = add(sum[v * 2 + 1], sum[v * 2 + 2]);
}

int get(int v, int tl, int tr, int L, int R, pii A) {
    //cerr << v << " " << tl << " " << tr << " " << L << " " << R << " " << "(" << A.fi << ", " << A.se << ")\n";
    if (tl >= R || L >= tr) {
        return -1;
    }
    //cerr << "1- " << tl << " " << tr << " " << mul(sum[v], rp[tl]) << " " <<getHash(A.fi + tl, A.fi + tr - 1) << "\n";
    if (mul(sum[v], rp[tl]) == getHash(A.fi + tl, min(A.se, A.fi + tr - 1))) {
        return tr - 1;
    }
    if (tl + 1 == tr) {
        return -1;
    }
    push(v);
    int tm = (tl + tr) / 2;
    //cerr << "2- " << tl << " " << tr << " " <<mul(sum[v * 2 + 1], rp[tl]) << " " <<getHash(A.fi + tl, A.fi + tm - 1) << "\n";
    if (mul(sum[v * 2 + 1], rp[tl]) == getHash(A.fi + tl, min(A.se, A.fi + tm - 1))) {
        int rres = get(v * 2 + 2, tm, tr, L, R, A);
        if (rres == -1) {
            return tm - 1;
        }
        return rres;
    }
    return get(v * 2 + 1, tl, tm, L, R, A);
}

int getValue(int v, int tl, int tr, int pos) {
    if (tl + 1 == tr) {
        return mul(sum[v], rp[tl]);
    }
    push(v);
    int tm = (tl + tr) / 2;
    if (pos < tm) {
        return getValue(v * 2 + 1, tl, tm, pos);
    }
    return getValue(v * 2 + 2, tm, tr, pos);
}

inline bool check(int i) { // True,        i-
    //cerr << "i = " << i << "\n";
    int len = borders[i].se - borders[i].fi + 1, equal_prefix = get(0, 0, m, 0, m, borders[i]);
    //cerr << "equal_prefix = " << equal_prefix << "\n";
    //cerr << "len = " << len << "\n";
    if (equal_prefix == m - 1 && equal_prefix == len - 1) {
        //cerr << "true\n";
        return true;
    }
    if (equal_prefix == len - 1) {
        //cerr << "false\n";
        return false;
    }
    if (equal_prefix == m - 1) {
        //cerr << "true\n";
        return true;
    }
    //cerr << "aye\n";
    return getValue(0, 0, m, equal_prefix + 1) < b[borders[i].fi + equal_prefix + 1];
}

int order[N];

inline int calc() {
    int lef = 0, rig = n + 1;
    while (lef + 1 < rig) {
        int mid = (lef + rig) / 2;
        //cerr << lef << " " << rig << "\n";
        if (check(order[mid])) {
            rig = mid;
        } else {
            lef = mid;
        }
    }
    return lef;
}

void solve() {
    precalc();
    string t;
    cin >> n >> q >> t;
    m = sz(t);
    for (int i = 0; i < m; ++i) {
        a[i] = t[i] - 'a' + 1;
    }
    for (int i = 1; i <= n; ++i) {
        cin >> t;
        borders[i].fi = ptr;
        for (int j = 0; j < sz(t); ++j) {
            b[ptr++] = t[j] - 'a' + 1;
        }
        borders[i].se = ptr - 1;
    }
    build(0, 0, m);
    for (int i = 0; i < ptr; ++i) {
        if (i) {
            h[i] = h[i - 1];
        }
        h[i] = add(h[i], mul(p[i], b[i]));
    }
    iota(order + 1, order + n + 1, 1);
    sort(order + 1, order + n + 1, cmpOrder);
    //for (int i = 1; i <= n; ++i) {
        //cerr << order[i] << " ";
    //}
    //cerr << "\n";
    cout << calc() << "\n";
    while (q--) {
        int k;
        char c;
        cin >> k >> c;
        int x = c - 'a' + 1;
        update(0, 0, m, k - 1, m, x);
        //for (int i = 1; i <= n; ++i) {
        //    cerr << order[i] << " ";
        //}
        //cerr << "\n";
        cout << calc() << "\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.in", "r", stdin);
#endif // LOCAC

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}
