#pragma GCC optimize("Ofast")
#pragma GCC target("avx2,sse4,popcnt")

#include <iostream>
#include <fstream>
#include <algorithm>
#include <functional>
#include <unordered_map>
#include <complex>
#include <array>
#include <chrono>
#include <random>
#include <vector>
#include <string>
#include <sstream>
#include <cmath>
#include <cstring>
#include <bitset>
#include <list>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <cassert>

#define sq(x) ((x) * (x))
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errp(x) cerr << "["#x"]  {" << ((x).first) << ", " << ((x).second) << "}\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n"

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template <typename T1, typename T2> inline bool relax(T1& a, const T2& b) {
    return a > b ? a = b, true : false;
}

template <typename T1, typename T2> inline bool strain(T1& a, const T2& b) {
    return a < b ? a = b, true : false;
}

// :::::::::::::::::::::::::::::::

// rusfree8049
// edefegecafy

const int N = 1e5 + 5, MOD = 1e9 + 7, MOD2 = 1e9 + 9;
const int BASE = 241, BASE2 = 13;

inline int add(int a, int b, int mod) {
    a += b;
    if (a >= mod)
        a -= mod;
    if (a < 0)
        a += mod;
    return a;
}

inline int mul(int a, int b, int mod) {
    return (1LL * a * b) % mod;
}

int n, m, bpw[N], bpw2[N], ban[26];
string s[N];
vector<int> pos[N][26];

void dfs(vector<int>& ind) {
    //    errv(ind);
    if (ind.size() == 1) return;
    
    vector<int> cnt(26);
    for (int i : ind) {
        vector<bool> ca(26);
        for (int j = 0; j < m; ++j) {
            ca[s[i][j] - 'a'] = 1;
        }
        for (int j = 0; j < 26; ++j)
            cnt[j] += ca[j];
    }
    
    int c = -1;
    for (int i = 0; i < 26; ++i) {
        if (!ban[i] && cnt[i] == ind.size()) {
            c = i;
            break;
        }
    }
    if (c == -1) {
        cout << "NO\n";
        exit(0);
    }
    
    vector<pair<vector<int>, int>> grs;
    for (int i : ind) {
        grs.emplace_back(pos[i][c], i);
    }
    sort(grs.begin(), grs.end());
    
    vector<vector<int>> ngrs;
    ngrs.push_back({grs[0].second});
    for (int i = 1; i < grs.size(); ++i) {
        if (grs[i].first == grs[i - 1].first) {
            ngrs.back().push_back(grs[i].second);
        } else {
            ngrs.push_back({grs[i].second});
        }
    }
    grs.clear();
    ind.clear();
    cnt.clear();
    
    ban[c] = 1;
    for (auto& v : ngrs)
        dfs(v);
    ban[c] = 0;
}

void solve() {
    cin >> m >> n;
    for (int i = 0; i < n; ++i)
        cin >> s[i];
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            pos[i][s[i][j] - 'a'].emplace_back(j);
        }
    }
    
    vector<int> ind(n);
    iota(ind.begin(), ind.end(), 0);
    dfs(ind);
    cout << "YES\n";
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(nullptr); cout.tie(nullptr);
    
    int t = 1;
    //    cin >> t;
    while (t--)
        solve();
    
    return 0;
}
