#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
#include <cmath>
using namespace std;
typedef long long ll;
typedef long double ld;

const ld INF = 1e18;
struct par{
    ll a, b, c;
    par(ll x,ll y, ll k){
        a = x;
        b = y;
        c = k;
    }
    par(){
        a = 0;
        b = 0;
        c = 0;
    }
};

pair<ld, ld> sq(par x, ld y){
    ld d = sqrt(x.b * x.b - 4 * x.a * (x.c - y));
    return make_pair(min((-x.b + d) / (2 * x.a), (-x.b - d) / (2 * x.a)), max((-x.b + d) / (2 * x.a), (-x.b - d) / (2 * x.a)));
}

int main(){
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);
    cout << fixed << setprecision(20);
    ll n;
    ld mx, mn;
    mx = -INF;
    mn = INF;
    cin >> n;
    par pars[n];
    for(ll i = 0; i < n; ++i){
        ll a, b, c;
        cin >> a >> b >> c;
        pars[i] = par(a, b, c);
        ld x = (ld)-b / (ld)(2 * a);
        ld y = a * x * x + b * x + c;
        if(a > 0) mx = max(y, mx);
        else mn = min(y, mn);
    }
    ld l = mx;
    ld r = mn;
    while(true){
        ld m1 = l + (r - l) / 3;
        ld m2 = l + (r - l) * 2 / 3;
        ld d1, d2;
        mx = -INF;
        mn = INF;
        for(par e : pars){
            auto x1 = sq(e, m1);
            mx = max(mx, x1.first);
            mn = min(mn, x1.second);
        }
        if(mx < mn){
            cout << (mn + mx) / 2 << ' ' << m1;
            exit(0);
        }
        d1 = mx - mn;
        mx = -INF;
        mn = INF;
        for(par e : pars){
            auto x1 = sq(e, m2);
            mx = max(mx, x1.first);
            mn = min(mn, x1.second);
        }
        if(mx < mn){
            cout << (mn + mx) / 2 << ' ' << m2;
            exit(0);
        }
        d2 = mx - mn;
        if(d1 < d2) l = m1;
        else r = m2;
    }

}
