#include <bits/stdc++.h>
using namespace std;
const int mod = 998244353;
vector<int> fact(200000, 1), inv_fact(200000, 1);

int add(int a, int b) {
    int res = a + b;
    if (res >= mod) {
        res -= mod;
    }
    return res;
}

int times(int a, int b) {
    long long res = a * 1ll * b;
    if (res >= mod) {
        res %= mod;
    }
    return res;
}

int bin_exp(int a, int b) {
    if (b == 0) {
        return 1;
    }
    int res = bin_exp(a, b / 2);
    res = times(res, res);
    if (b % 2 == 1) {
        res = times(res, a);
    }
    return res;
}

void init() {
    for (int i = 1; i < 200000; ++i) {
        fact[i] = times(fact[i - 1], i);
    }
    /*(k - 1)! * k = k!
    k * 1 / k! = 1 / (k - 1)!*/
    inv_fact[199999] = bin_exp(fact[199999], mod - 2);
    for (int i = 199999; i > 0; --i) {
        inv_fact[i - 1] = times(inv_fact[i], i);
    }
}

int C(int n, int k) {
    if (n < k || n < 0 || k < 0) { return 0; }
    return times(fact[n], times(inv_fact[k], inv_fact[n - k]));
}

void solve() {
    init();
    int n, m;
    cin >> n >> m;
    int k = C(n + m - 2, n - 1);
    //cout << k << ' ' << add(k, 1) << ' ' << times(k, add(k, 1)) << '\n';
    //cout << bin_exp(2, mod - 2) << ' ' << times(times(k, add(k, 1)), bin_exp(2, mod - 2)) << '\n';
    cout << times(times(k, add(k, 1)), bin_exp(2, mod - 2)) << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
