#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <fstream>
#include <iomanip>
#include <assert.h>
#include <numeric>
#include <algorithm>
#include<vector>
#include<queue>
#include<set>
#include<map>
#include<math.h>
#include<string>
#include<random>
#include<cmath>
#include <stack>

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#define endl '\n'
#define all(v) v.begin(), v.end()
#define mp make_pair
#define pb push_back

const int N = 5e5 + 10;

struct P
{
    ld a, b, c;
    P() {}
    P(int x, int y, int z) :a(x), b(y), c(z) {}
    ld operator()(ld x)
    {
        return x * x * a + x * b + c;
    }
    ld v()
    {
        return -b / (2 * a);
    }
    pair<ld, ld> root()
    {
        return mp((-b - sqrtl(b * b - 4 * a * c)) / (2 * a), (-b + sqrtl(b * b - 4 * a * c)) / (2 * a));
    }
    friend P operator-=(P& a, P b)
    {
        a.a -= b.a;
        a.b -= b.b;
        a.c -= b.c;
        return a;
    }
    friend P operator-(P a, P b)
    {
        return a -= b;
    }
};

vector<P> p;

const ll mod = 1e9 + 7;

ll a[N], b[N];

int mnl[N], mnr[N];

ll prefsum[N];

vector<int> coord;

struct Node
{
    Node* l, * r;
    int x;
    Node()
    {
        l = nullptr;
        r = nullptr;
        x = 0;
    }
    Node(int a)
    {
        l = r = nullptr;
        x = a;
    }
};

Node* build(int L = 0, int R = (1 << 19))
{
    auto now = new Node();
    if (L + 1 == R)
        return now;
    now->l = build(L, (L + R) / 2);
    now->r = build((L + R) / 2, R);
    return now;
}

Node* walk(Node* root, int x, int L = 0, int R = (1 << 19))
{
    if (L == x && L + 1 == R)
    {
        auto now = new Node();
        now->x = root->x + 1;
        return now;
    }
    int M = (L + R) / 2;
    Node* now = new Node();
    if (x < M)
    {
        now->l = walk(root->l, x, L, M);
        now->r = root->r;
    }
    else
    {
        now->r = walk(root->r, x, M, R);
        now->l = root->l;
    }
    return now;
}

int q(Node* root, int x, int L = 0, int R = (1 << 19))
{
    if (L == x && R - 1 == L)
        return root->x;
    int M = (L + R) / 2;
    if (x < M)
    {
        return q(root->l, x, L, M);
    }
    else
    {
        return q(root->r, x, M, R);
    }
}

Node* root[N];

int que(int l, int r, int x)
{
    int ans = 0;
    if (l == 0 && x == 0)
    {
        ans++;
    }
    x = lower_bound(all(coord), x) - coord.begin();
    return ans + q(root[r], x) - q(root[l], x);
}

int pref[N];

signed main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, k;
    cin >> n >> k;
    for (int q = 0; q < n; q++)
    {
        cin >> a[q] >> b[q];
        if (a[q] < b[q])
        {
            swap(a[q], b[q]);
        }
    }
    prefsum[0] = a[0] % k;
    for (int q = 1; q < n; q++)
    {
        prefsum[q] = (prefsum[q - 1] + a[q]) % k;
        pref[q] = pref[q - 1] + a[q];
        coord.push_back(prefsum[q]);
    }
    sort(all(coord));
    coord.resize(unique(all(coord)) - coord.begin());
    root[0] = build();
    for (int i = 0; i < n; i++)
    {
        root[i + 1] = walk(root[i], lower_bound(all(coord), prefsum[i]) - coord.begin());
    }
    ll ans = 0;
    for (int q = 0; q < n; q++)
    {
        ans = (ans + a[q] * (q + 1) % mod * (n - q) % mod) % mod;
    }
    vector<int> valid;
    for (int q = 0; q < n; q++)
    {
        if ((a[q] - b[q]) % k != 0)
        {
            valid.push_back(q);
        }
    }
    if (valid.size() == 0)
    {
        map<int, pair<ll, int>> ost;
        ll sum = 0;
        ost[0] = mp(0, 1);
        for (int q = 0; q < n; q++)
        {
            sum = (sum + a[q]) % mod;
            ost[prefsum[q]].first = (ost[prefsum[q]].first + sum) % mod;
            ost[prefsum[q]].second += 1;
            ans = (ans + ost[prefsum[q]].first - sum * ost[prefsum[q]].second % mod + mod) % mod;
        }
        cout << ans;
        return 0;
    }
    stack<pair<int, int>> al;
    al.push(mp(a[valid[0]] - b[valid[0]], 0));
    int pos = 1;
    while (pos != valid.size())
    {
        while (al.size() && a[valid[pos]] - b[valid[pos]] <= al.top().first)
        {
            mnr[al.top().second] = valid[pos] - 1;
            al.pop();
        }
        al.push(mp(a[valid[pos]] - b[valid[pos]], pos));
        pos++;
    }
    while (al.size())
    {
        mnr[al.top().second] = n - 1;
        al.pop();
    }
    al.push(mp(a[valid[valid.size() - 1]] - b[valid[valid.size() - 1]], valid.size() - 1));
    pos = valid.size() - 2;
    while (pos != -1)
    {
        while (al.size() && a[valid[pos]] - b[valid[pos]] <= al.top().first)
        {
            mnl[al.top().second] = valid[pos] + 1;
            al.pop();
        }
        al.push(mp(a[valid[pos]] - b[valid[pos]], pos));
        pos--;
    }
    while (al.size())
    {
        mnl[al.top().second] = 0;
        al.pop();
    }
    for (int w = 0; w < valid.size(); w++)
    {
        int l = mnl[w];
        int m = valid[w];
        int r = mnr[w];
        if (l == m && m == r)
        {
            if (a[valid[w]] % k == 0)
            {
                ans = (ans - a[valid[w]] + b[valid[w]] + mod) % mod;
            }
            continue;
        }
        if (m - l < r - m)
        {
            for (int q = l; q <= m; q++)
            {
                ans = (ans - (a[valid[w]] - b[valid[w]]) * que(m, r + 1, prefsum[q - 1]) % mod + mod) % mod;
            }
        }
        else
        {
            for (int q = m; q <= r; q++)
            {
                ans = (ans - (a[valid[w]] - b[valid[w]]) * que(l, m, prefsum[q]) % mod + mod) % mod;
            }
        }
    }
    cout << ans << '\n';
}