﻿#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <vector>
#include <queue>
#include <iomanip>
using namespace std;
const int N = 1e5+10;

#define int long long
const int q = 31;
const int Mod = 998244353;
const int Mod1 = 1e9 + 7;
vector <int> mac[N][q];
pair <int, int> hesh[N];
queue <pair <int, int>> qu;
int timer = 0;
int used[q];
vector <int> sames;
int st_qu[N];
int st_qu1[N];

int make_hesh(int x, int y)
{
    return (x * st_qu[y]) % Mod;
}

void find_same(int L,int R)
{
    for (int i = L; i < R; i++)
    {
        for (int j = 1; j <= 26; j++)
        {
            int i1 = hesh[i].second;
            if (mac[i1][j].size() > 0)
            {
                used[j]++;
            }
        }
    }
    for (int i = 1; i <= 26; i++)
    {
        if (used[i] == R - L)
        {
            sames.push_back(i);
        }
        used[i] = 0;
    }
    if (sames.size() == 0)
    {
        cout << "NO";
        exit(0);
    }
}

void switch_sames(int L, int R)
{
    for (int i = L; i < R; i++)
    {
        for (int x:sames)
        {
            int i1 = hesh[i].second;
            for(int y : mac[i1][x])
            {
                hesh[i].first += make_hesh(x, y);
                hesh[i].first %= Mod;
            }
            mac[i1][x].clear();
        }
    }
}

signed main()
{
    //freopen("TextFile2.txt", "r", stdin);
    int a, b;
    cin >> a >> b;
    st_qu[0] = 1;
    st_qu1[0] = 1;
    for (int i = 1; i <= a; i++)
    {
        st_qu[i] = st_qu[i - 1] * q;
        st_qu[i] %= Mod;
        st_qu1[i] = st_qu1[i - 1] * q;
        st_qu1[i] %= Mod1;
    }
    for (int i = 0; i < b + 10; i++)
    {
        hesh[i].second = i;
    }
    for (int i = 0; i < b; i++)
    {
        string s;
        cin >> s;
        for (int j = 0; j < a; j++)
        {
            mac[i][s[j]-'a' + 1].push_back(j);
        }
    }
    qu.push({ 0,b });
    while (!qu.empty())
    {
        pair <int, int> x = qu.front();
        qu.pop();
        find_same(x.first, x.second);
        switch_sames(x.first, x.second);
        sames.clear();
        sort(hesh + x.first, hesh + x.second);
        int j = 0;
        for (int i = x.first; i < x.second; i++)
        {
            if (i==x.second-1 || hesh[i].first != hesh[i + 1].first)
            {
                if(i-j>0)
                    qu.push({ j,i + 1 });
                j = i + 1;
            }
        }
    }
    cout << "YES";
}