#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <stack>
#include <string>
#include <numeric>
#include <cmath>
#include <bitset>
#include <set>

using namespace  std;
#define int long long

typedef long long ll;

#define range(i, n) for (int i = 0; i < (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)

#define all(a) (a).begin(), (a).end()

bool ok(vector<int> arr, int k) {
    int n = arr.size();
    ll sum = 0;
    stack<int> right_free, left_free;
    rrange(i, n) {
        sum += arr[i];
        if (arr[i] > 0) {
            right_free.push(i);
        }
    }
    range(i, n) {
        sum -= arr[i];
        if (arr[i] > 0) {
            right_free.pop();
            left_free.push(i);
        } else {
            while (arr[i] < 0) {
                bool good_left = !left_free.empty() && abs(left_free.top() - i) <= k;
                bool good_right = !right_free.empty() && abs(right_free.top() - i) <= k && sum > 0;
                if (!good_right && !good_left) return false;
                if (good_left) {
                    int j = left_free.top();
                    int t = min(arr[j], -arr[i]);
                    arr[j] -= t;
                    arr[i] += t;
                    if (arr[j] == 0) left_free.pop();
                } else {
                    int j = right_free.top();
                    int t = min(arr[j], -arr[i]);
                    t = min(sum, t);
                    arr[j] -= t;
                    sum -= t;
                    arr[i] += t;
                    if (arr[j] == 0) right_free.pop();
                }
            }
        }
    }
    return true;
}

signed main() {
    int n;
    cin>>n;
    vector<int> arr(n);
    range(i, n) cin >> arr[i];
    ll sum = 0;
    range(i,n) {
        int x; cin >> x;
        arr[i] = x - arr[i];
        sum += arr[i];
    }
    if (sum < 0) {
        cout << -1;
        return 0;
    }
    int l = -1; int r = n;
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (ok(arr, m)) {
            r = m;
        } else {
            l = m;
        }
    }
    cout << r << endl;
    return 0;
}

/*
 4
6 14 70 1
70 3 16 5
 */
