//
// Created by olymp on 12.12.2021.
//

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

#include <string>
#include <numeric>
#include <cmath>
#include <bitset>
#include <set>
#include <cfloat>
#include <iomanip>
#include <stack>
#include <random>

using namespace  std;
#define int long long

typedef long long ll;

#define range(i, n) for (int i = 0; i < (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)

struct Point{
    int x,cnt;

    Point(int x,int cnt):x(x),cnt(cnt){};

    Point(){};
};

const int64_t MOD = 1'000'000'007;
#define int32_t int64_t
#define int int64_t

struct Stack {
    stack<Point> stack;
    int sm = 0;
    int32_t sm_inf = 0;
    int32_t cnt_inf = 0;

    Stack(){};

    void push(int32_t x, int32_t sum) {
        int32_t coef = 1;
        while(stack.size() > 0 && stack.top().x > x) {
            if(stack.top().x == INT32_MAX) {
                sm_inf = (sm_inf - stack.top().cnt + MOD) % MOD;
                cnt_inf--;
                coef++;
            } else {
                sm = (sm - ((int64_t)stack.top().x * stack.top().cnt) % MOD + MOD) % MOD;
                coef += stack.top().cnt;
            }
            stack.pop();
        }

        if(x == INT32_MAX) {
            stack.push(Point(x, sum));
            sm_inf += ((int64_t)stack.top().cnt) % MOD;
            sm_inf %= MOD;
            cnt_inf++;
        } else {
            sm += ((int64_t)x * coef) % MOD;
            sm %= MOD;
            stack.push(Point(x, coef));
        }
    }
};

int32_t** table;

int32_t query(int32_t left, int32_t right) {
    int32_t len = right - left + 1;
    int32_t level = 31 - __builtin_clz(len);
    return std::min(table[level][left], table[level][right - (1 << level) + 1]);
}

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int32_t n, k;
    std::cin >> n >> k;

    std::mt19937 rng;
    for(int32_t y = 0; y  < 1; y++) {
        std::pair<int32_t, int32_t> *arr = new std::pair<int32_t, int32_t>[n];
        for (int32_t i = 0; i < n; i++)
            std::cin >> arr[i].first >> arr[i].second;
            //arr[i] = {rng() % 1'000'000'000, rng() % 1'000'000'000};

        int32_t *pref_sum = new int32_t[n + 1];
        pref_sum[0] = 0;
        for (int32_t i = 1; i <= n; i++)
            pref_sum[i] = (pref_sum[i - 1] + std::max(arr[i - 1].first, arr[i - 1].second)) % MOD;

        int32_t *dif = new int32_t[n];
        for (int32_t i = 0; i < n; i++)
            dif[i] = std::abs(arr[i].first - arr[i].second);

        int32_t max_level = 0;
        while ((1 << max_level) <= n)
            max_level++;
        max_level--;

        table = new int32_t *[max_level + 1];
        for (int32_t i = 0; i <= max_level; i++) {
            table[i] = new int32_t[n - (1 << i) + 1];
            for (int32_t j = 0; j < n - (1 << i) + 1; j++)
                if (i == 0)
                    table[i][j] = (dif[j] % k == 0 ? INT32_MAX : dif[j]);
                else
                    table[i][j] = std::min(table[i - 1][j], table[i - 1][j + (1 << i) / 2]);
        }

        int32_t ans = 0;
        for (int32_t i = 0; i < n; i++) {
            int32_t cnt = (int64_t) ((i + 1) * (n - i)) % MOD;
            ans += ((int64_t) std::max(arr[i].first, arr[i].second) * cnt) % MOD;
            ans %= MOD;
        }

        map<int, Stack> mp;
        map<int, int> mp_v;
        mp_v[0] = 0;
        int64_t pref = 0;
        for (int i = 0; i < n; i++) {
            pref += std::max(arr[i].first, arr[i].second);

            if (mp_v.find(pref % k) == mp_v.end()) {
                mp_v[pref % k] = i + 1;
                continue;
            }

            int32_t prev_prefix = mp_v[pref % k];
            int32_t x = query(prev_prefix, i);

            if (x != INT32_MAX)
                mp[pref % k].push(x, 0);
            else {
                int32_t last = (pref_sum[i + 1] - pref_sum[prev_prefix] + MOD) % MOD;
                mp[pref % k].push(x, ((int64_t) last * (mp[pref % k].cnt_inf + 1)) % MOD);
            }
            mp_v[pref % k] = i + 1;

            ans = (ans - mp[pref % k].sm + MOD) % MOD;
            ans = (ans - mp[pref % k].sm_inf + MOD) % MOD;
        }

        std::cout << ans << "\n";

        /*int64_t ans2 = 0;
        for(int32_t i = 0; i < n; i++) {
            for(int32_t j = i; j < n; j++) {
                //i to j
                int64_t sum_max = 0;
                for(int32_t p = 0; p < (1 << (j - i + 1)); p++) {
                    int64_t sum = 0;
                    for(int32_t q = 0; q <= j - i; q++)
                        if(p & (1 << q))
                           sum += arr[i + q].first;
                        else
                            sum += arr[i + q].second;
                    if(sum % k != 0)
                        sum_max = std::max(sum_max, sum);
                }
                ans2 += sum_max;
                ans2 %= MOD;
            }
        }

        int a = 0;
        if(ans != ans2 % MOD)
            a++;*/
    }
    return 0;
}

/*
3 3
1 2
2 3
3 1
 */

/*
 5 5
 4 1
 4 2
 2 3
 2 4
 1 5
 */