#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <complex>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <ctime>

using namespace std;

#define en '\n'
#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
//#define sz(x) (int)((x).size())

typedef long long ll;
//typedef __int128_t int128;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef complex<long double> comp;

const int INF = 1e9 + 7;
const ll INFLL = 1e18;
const long double EPS = 1e-9;
const long double PI = acos(-1);

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

ld START_TIME, TIME;

void solve() {

}

vector<map<int, int>> go;
vector<int> cz, sz, ccnt;

vector<vector<int>> up;
vector<unordered_map<int, vector<int>>> down;

void add(string& s) {
    int v = 0;
    for (auto& ch : s) {
        if (!go[v].count(ch)) {
            go[v][ch] = go.size();
            go.emplace_back(map<int, int>());
        }
        v = go[v][ch];
    }
    cz.resize(go.size());
    cz[v]++;
}

void dfs(int v, int cc, int pr = -1) {
    sz[v] += cz[v];
    cc += sz[v];
    ccnt[v] = cc;
    if (pr != -1) {
        up[v].resize(up[pr].size() + 1);
        up[v][0] = pr;
        for (int l = 1; l < up[v].size(); ++l) {
            if (up[up[v][l - 1]].size() < (l)) break;
            up[v][l] = up[up[v][l - 1]][l - 1];
        }
    }
    for (auto& i : go[v]) {
        char ch = i.first;
        int u = i.second;
        dfs(u, cc, v);
        cc += sz[u];
        sz[v] += sz[u];
        down[v][ch].resize(down[u][ch].size() + 1);
        down[v][ch][0] = u;
        for (int l = 1; l < down[v][ch].size(); ++l) {
            if (down[down[v][ch][l - 1]][ch].size() < l - 1) down[v][ch][l] = -1;
            else down[v][ch][l] = down[down[v][ch][l - 1]][ch][l - 1];
        }
    }
}

int v = 0, h = 0;

void setup(string& s) {
    for (char& ch : s) {
        if (!go[v].count(ch)) return;
        h++;
        v = go[v][ch];
    }
}

void go_upper(int in) {
    for (int i = 22; i >= 0; --i) {
        if (h - (1 << i) < in) continue;
        v = up[v][i];
        h -= (1 << i);
    }
}

void go_down(char ch, int mx) {
    for (int i = 22; i >= 0; --i) {
        if (!go[v].count(ch)) break;
        if (h + (1 << i) > mx) continue;
        if (down[v][ch].size() <= i) continue;
        if (down[v][ch][i] == -1) continue;
        h += (1 << i);
        v = down[v][ch][i];
    }
}

int ans(int len, char nxt) {
    if (h == len) {
        int res = ccnt[v] - cz[v];
        return res;
    } else {
        int res = ccnt[v];
        for (auto& it : go[v]) {
            if (it.first < nxt) {
                res += sz[it.second];
            }
        }
        return res;
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    START_TIME = clock();
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    solve();
#ifdef LOCAL
    TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
    cerr << endl << TIME * 1000 << " ms." << endl;
#endif
    int n, q;
    cin >> n >> q;
    string s, ss;
    cin >> s;
    go.emplace_back(map<int, int>());
    for (int i = 0; i < n; ++i) {
        cin >> ss;
        add(ss);
    };
    up.resize(go.size());
    down.resize(go.size());
    ccnt.resize(go.size());
    sz.resize(go.size());
    cz.resize(go.size());
    dfs(0, 0);
    setup(s);
    int in;
    char ch;
    char chpr = -1;
    if (h == s.size()) {
        chpr = -1;
        cout << ans(s.size(), '0') << '\n';
    } else {
        ch = s[h];
        cout << ans(s.size(), s[h]) << '\n';
    }
    for (int i = 0; i < q; ++i) {
        cin >> in >> ch;
        go_upper(in - 1);
        if (h < (in - 1))
            ch = chpr;
        else
            chpr = ch;
        go_down(ch, s.size());
        cout << ans(s.size(), ch) << '\n';
    }
    return 0;
}