#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <complex>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <ctime>

using namespace std;

#define en '\n'
#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
//typedef __int128_t int128;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef complex<long double> comp;

const int INF = 1e9 + 7;
const ll INFLL = 1e18;
const long double EPS = 1e-9;
const long double PI = acos(-1);

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

ld START_TIME, TIME;

const ll MOD = 1e9 + 7;

struct thash {
    ll x = 0;
    thash() {}
    thash(ll x) : x(x % MOD) {}
    thash operator+(const thash& obj) const {
        return {x + obj.x};
    }
    thash operator*(const thash& obj) const {
        return {x * obj.x};
    }
    bool operator<(const thash& obj) const {
        return (x < obj.x);
    }
    bool operator==(const thash& obj) const {
        return (x == obj.x);
    }
};

const ll P = 179;
vector<thash> p;

vector<string> ss;
vector<int> masks;
vector<thash> hashes;

bool solve(vector<int> &id, int prev_mask) {
    if (sz(id) <= 1) {
        return 1;
    }
    int now = masks[id[0]];
    for (auto i: id) {
        now &= masks[i];
    }
    if (now == prev_mask) {
        return 0;
    }
    int new_mask = now ^ prev_mask;
    map<thash, vector<int>> classes;
    for (auto i : id) {
        for (int j = 0; j < sz(ss[i]); ++j) {
            int num = (ss[i][j] - 'a');
            if (new_mask & (1 << num)) {
                hashes[i] = hashes[i] + ((thash)ss[i][j] * p[sz(ss[i]) - j - 1]);
            }
        }
        classes[hashes[i]].emplace_back(i);
    }
    bool res = 1;
    for (auto &i: classes) {
        res &= solve(i.second, now);
    }
    return res;
}

void solve() {
    int l, n;
    cin >> l >> n;
    ss.resize(n);
    masks.resize(n);
    p.resize(n);
    hashes.resize(n);
    p[0] = 1;
    for (int i = 1; i < n; ++i) {
        p[i] = p[i - 1] * P;
    }
    for (int i = 0; i < n; ++i) {
        cin >> ss[i];
        for (auto it : ss[i]) {
            masks[i] |= (1 << ((int)(it - 'a')));
        }
    }
    vector<int> id(n);
    iota(all(id), 0);
    if (solve(id, 0)) {
        cout << "YES";
    }
    else {
        cout << "NO";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    START_TIME = clock();
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    solve();
#ifdef LOCAL
    TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
    cerr << endl << TIME * 1000 << " ms." << endl;
#endif
    return 0;
}