#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <unordered_set>
#include <cmath>
#include <random>
#include <bitset>
#include <algorithm>

#define int long long
#define double long double


using namespace std;

const double eps = 1;

void solve() {
    int n;
    cin >> n;
    vector<tuple<int, int, int>> p1, p2;
    for (int i = 0; i < n; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        if (a < 0)
            p2.push_back({a, b, c});
        else
            p1.push_back({a, b, c});
    }
    double l = -1e10, r = 1e10;
    while (r - l > eps) {
        double m1 = (l + r) / 2;
        double m2 = m1 + eps;
        double up1 = -1e20;
        double down1 = 1e20;
        double up2 = -1e20;
        double down2 = 1e20;
        for (auto[a, b, c] : p1) {
            up1 = max(up1, a * m1 * m1 + b * m1 + c);
            up2 = max(up2, a * m2 * m2 + b * m2 + c);
        }
        for (auto[a, b, c] : p2) {
            down1 = min(down1, a * m1 * m1 + b * m1 + c);
            down2 = min(down2, a * m2 * m2 + b * m2 + c);
        }
        double d1 = up1 - down1;
        double d2 = up2 - down2;
        if (d1 > d2)
            l = m1;
        else
            r = m1;
    }
    double x = r;
    double y = -1e18;
    for (auto[a, b, c] : p1) {
        y = max(y, a * x * x + b * x + c);
    }
    cout << x << " " << y << '\n';
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    cout.setf(ios::fixed);
    cout.precision(10);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.setf(ios::fixed);
    cout.precision(10);
#endif

    solve();
}
