#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <cmath>
#include <utility>
#include <queue>
#include <set>
#include <map>
#include <iomanip>
#include <deque>

#define ll long long
#define ld long double
#define vll vector<long long>
#define INF {1000000000, -1};

using namespace std;

pair<ld, ld> f1(ld mnl, ld mxl, ld mnr, ld mxr)
{
    if (mnl > mnr){
        return INF;
    }
    ld k = mnl / mnr;
    mxr *= k;
    if (mxr > mxl){
        return INF;
    }
    return {mxl - mnl, k};
}

pair<ld, ld> f2(ld mnl, ld mxl, ld mnr, ld mxr)
{
    if (mnl > mnr){
        return INF;
    }
    if (mxr < mxl){
        return INF;
    }
    ld k1 = mnl / mnr, k2 = mxl / mxr;
    ld k = max(k1, k2);
    mxr *= k;
    return {mxr - mnl, k};
}

pair<ld, ld> f3(ld mnl, ld mxl, ld mnr, ld mxr)
{
    ld k1 = min((ld)1, mxl / mxr), k2 = min(mnl / mnr, (ld)1);
    ld k = min(k1, k2);
    mnr *= k;
    return {mxl - mnr, k};
}

pair<ld, ld> f4(ld mnl, ld mxl, ld mnr, ld mxr)
{
    if (mxr < mxl){
        return INF;
    }
    ld k = mxl / mxr;
    mnr *= k;
    mxr *= k;
    if (mnr > mnl){
        return INF;
    }
    return {mxr - mnr, k};
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n;
    cin >> n;
    vll a(n);
    vll mnl(n), mxl(n);
    vll mnr(n), mxr(n);
    for(ll i = 0; i < n; ++i){
        ll x;
        cin >> x;
        a[i] = x;
        if (i == 0){
            mnl[i] = x; mxl[i] = x;
        }
        else{
            mnl[i] = min(mnl[i - 1], x); mxl[i] = max(mxl[i - 1], x);
        }
    }
    for(ll i = n - 1; i >= 0; --i){
        ll x;
        x = a[i];
        if (i == n - 1){
            mnr[i] = x; mxr[i] = x;
        }
        else{
            mnr[i] = min(mnr[i + 1], x); mxr[i] = max(mxr[i + 1], x);
        }
    }
    cout << 1 << ' ';
    for(ll i = 1; i < n; ++i){
        ld mn1 = mnl[i - 1], mx1 = mxl[i - 1];
        ld mn2 = mnr[i], mx2 = mxr[i];
        pair<ld, ld> x1, x2, x3, x4;
        x1 = f1(mn1, mx1, mn2, mx2);
        x2 = f2(mn1, mx1, mn2, mx2);
        x3 = f3(mn1, mx1, mn2, mx2);
        x4 = f4(mn1, mx1, mn2, mx2);
        pair<ld, ld> p = min(x1, min(x2, min(x3, x4)));
        ld otv = p.second;
        if (otv == 1){
            otv = 0;
        }
        cout << fixed << setprecision(12) << 1 - otv << ' ';
    }
}