#pragma GCC target("avx,avx2")
#pragma GCC optimaze("Ofast")
#pragma GCC optimaze("unroll-loops")
#pragma GCC optimaze("fast-math")
#pragma GCC optimaze("no-stack-protector")
#pragma GCC optimaze("unswitch-loops")
#pragma GCC optimaze("rename-registers")

#include<bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define forn(i, n) for(int i = 0; i < int(n); i++)

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const ll md1 = 1e9 + 7, md2 = 1e9 + 9;
const ll p2 = 300 + rnd() % 200, p1 = 200 + rnd() % 300;

pair<int, int> get_hash(vector<bool> &temp) {
    vector<int> arr;
    forn(i, temp.size()) {
        arr.push_back(temp[i] + 10);
    }
    ll h1 = arr[0], h2 = arr[0];
    for(int i = 1; i < arr.size(); i++) {
        h1 = (h1 * p1 % md1 + arr[i]) % md1;
        h2 = (h2 * p2 % md2 + arr[i]) % md2;
    }
    return {h1, h2};
}

int n, l;

bool build_ans(vector<string> arr, bitset<26> uze) {
    if (arr.size() <= 1) {
        return true;
    }

    vector<int> cnt(26);

    for(const auto &i : arr) {
        bitset<26> b;

        for(const auto &j : i) {
            b[j-'a'] = 1;
        }

        forn(j, 26) {
            cnt[j] += b[j];
        }
    }

    bitset<26> know;
    forn(i, 26) {
        if (cnt[i] == arr.size() && !uze[i]) {
            know[i] = 1;
            uze[i] = 1;
        }
    }

    if (know.count() == 0) {
        return false;
    }

    map<pair<int, int>, vector<int>> mapa;
    forn(i, arr.size()) {
        vector<bool> used(l);
        forn(j, l) {
            if (!know[arr[i][j] - 'a']) {
                used[j] = true;
            }
        }

        pair<int, int> h = get_hash(used);
        mapa[h].push_back(i);
    }

    for(const auto &i : mapa) {
        vector<string> temp;
        for(const auto &j : i.second) {
            temp.push_back(arr[j]);
        }

        bool res = build_ans(temp, uze);
        if (!res) {
            return false;
        }
    }

    return true;
}

void solve() {
    cin >> l >> n;

    vector<string> arr(n);

    forn(i, n) {
        cin >> arr[i];
    }

    bitset<26> uze;
    bool res = build_ans(arr, uze);

    if (res) {

        cout << "YES";
    }
    else {
        cout << "NO";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);
    cout.setf(ios::fixed);
    cout.precision(20);

//    #ifndef ONLINE_JUDGE
//        freopen("input.txt", "r", stdin);
//        freopen("output.txt", "w", stdout);
//        freopen("error.txt", "w", stderr);
//    #endif // ONLINE_JUDGE

    solve();

    return 0;
}
