#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;

const ld EPS = 1e-10;

bool eq(const ld& a, const ld& b)
{
	return abs(a - b) <= EPS;
}

bool ls(const ld& a, const ld& b)
{
	return a < b && !eq(a, b);
}

bool lq(const ld& a, const ld& b)
{
	return a < b || eq(a, b);
}

ld a, b, c, d;
vector <pair <int, ld>> x;

struct an
{
	ld ans = -1e18;
	vector <int> perm;
	vector <ld> ar;

	an() {}

	an(ld ans, vector<int> perm, vector <ld> ar) : ans(ans), perm(perm), ar(ar) {}

	bool operator<(const an& b) const
	{
		return ls(ans, b.ans);
	}
};

an ans;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> a >> b >> c >> d;

	x.push_back({ 1, a });
	x.push_back({ 2, b });
	x.push_back({ 3, c });
	x.push_back({ 4, d });

	do
	{
		vector <int> perm;
		for (auto i : x) perm.push_back(i.first);
		a = x[0].second, b = x[1].second, c = x[2].second, d = x[3].second;
		
		ld va = (a - 1) * (d - 1), vb = (c - 1) * (b - 1);
		if (eq(va, vb))
		{

		}
		else if (ls(va, vb))
		{
			if (ls(b, c))
			{
				b = va / (c - 1) + 1;
			}
			else
			{
				c = va / (b - 1) + 1;
			}
		}
		else
		{
			if (ls(a, d))
			{
				a = vb / (d - 1) + 1;
			}
			else
			{
				d = vb / (a - 1) + 1;
			}
		}

		an nans = an(a * d + b + c, perm, { a, b, c, d });
		ans = max(ans, nans);
	} while (next_permutation(x.begin(), x.end()));

	for (auto i : ans.perm) cout << i << ' ';
	cout << '\n';
	for (auto i : ans.ar) cout << fixed << setprecision(20) << i << ' ';
	cout << '\n';
	return 0;
}