// VkoshpKostroma.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

//Kostroma

#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <stack>

using namespace std;

long double get_t(long double a, long double b) {
	if (a > b) {
		return 0;
	}
	else {
		return 1 - a / b;
	}
}

long double maximum(long double a, long double b, long double c, long double d) {
	return max(max(a, b), max(c, d));
}

long double minimum(long double a, long double b, long double c, long double d) {
	return min(min(a, b), min(c, d));
}

long double get_abs(long double a, long double b, long double c, long double d) {
	return maximum(a, b, c, d) - minimum(a, b, c, d);
}

long double check(long double a, long double b, long double c, long double d, long double t11, long double t10, long double t01, long double t00) {
	long double a11 = get_abs(a, b, c * t11, d * t11);
	long double a10 = get_abs(a, b, c * t10, d * t10);
	long double a01 = get_abs(a, b, c * t01, d * t01);
	long double a00 = get_abs(a, b, c * t00, d * t00);
	long double ans = minimum(a11, a10, a01, a00);
	if (ans == a11) {
		return t11;
	}
	if (ans == a10) {
		return t10;
	}
	if (ans == a01) {
		return t01;
	}
	return t00;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout << fixed << setprecision(12);
	int n;
	cin >> n;
	vector<int> data(n);
	for (int i = 0; i < n; ++i) {
		cin >> data[i];
	}
	cout << 1 << ' ';
	int minim = data[0];
	int maxim = data[0];
	vector<int> minim_s(n);
	vector<int> maxim_s(n);
	minim_s[n - 1] = data[n - 1];
	maxim_s[n - 1] = data[n - 1];
	for (int i = n - 2; i >= 0; --i) {
		minim_s[i] = min(data[i], minim_s[i + 1]);
		maxim_s[i] = max(data[i], maxim_s[i + 1]);
	}
	for (int i = 1; i < n; ++i) {
		long double t11 = get_t(maxim, maxim_s[i]);
		long double t10 = get_t(maxim, minim_s[i]);
		long double t01 = get_t(minim, maxim_s[i]);
		long double t00 = get_t(minim, minim_s[i]);
		//cout << t11 << ' ' << t10 << ' ' << t01 << ' ' << t00 << endl;
		cout << 1 - check(maxim, minim, maxim_s[i], minim_s[i], 1 - t11, 1 - t10, 1 - t01, 1 - t00) << ' ';
		minim = min(minim, data[i]);
		maxim = max(maxim, data[i]);
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
