// 

#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <unordered_map>


//#pragma GCC target("avx")
//#pragma GCC optimize(3)
//#pragma GCC optimize("inline-functions")



#define ll long long
#define ld long double
#define pr pair<ll, ll>
#define vl vector<ll>
#define all(a) (a.begin(), a.end())

using namespace std;

const ll MAXN = 500000 + 13;
const ll INF = 1000000000000000000;
const ll MOD = 1e9 + 7;

ll k;
pr tree[4 * MAXN];
ll a[MAXN], b[MAXN];
ll sz = 1;

void build(ll v, ll l, ll r) {
	if (r - l == 1) {
		tree[v] = { (((a[l] - b[l]) % k) ? a[l] - b[l] : INF) , l};
	}
	else {
		ll m = (l + r) / 2;
		build(2 * v + 1, l, m);
		build(2 * v + 2, m, r);
		tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
	}
}


//lx, rx - ,   
pr get(ll v, ll l, ll r, ll lx, ll rx){
	if (l >= rx || r <= lx) {
		return { INF, INF };
	}
	if (l >= lx && r <= rx) {
		return tree[v];
	}
	ll m = (l + r) / 2;
	pr res1 = get(2 * v + 1, l, m, lx, rx);
	pr res2 = get(2 * v + 2, m, r, lx, rx);
	return min(res1, res2);
}

ll summ2 = 0;

void rec(vl::iterator begin, vl::iterator l, vl::iterator r) {
	if (l == r) {
		return;
	}
	pr mini = get(0, l - begin, r - begin, 0, sz);
	ll pos = lower_bound(l, r, mini.second) - l;
	summ2 += mini.first * (pos + 1) * ((ll)(r - l) - pos);
	summ2 = (summ2 + MOD) % MOD;

	rec(begin, l + 1, l + pos);
	rec(begin, l + pos + 1, r);
}




void solve() {
	ll n;
	cin >> n >> k;
	while (sz <= n) {
		sz *= 2;
	}
	ll num1, num2;
	for (ll i = 0; i < n; i++) {
		cin >> num1 >> num2;
		if (num1 < num2) {
			swap(num1, num2);
		}
		a[i] = num1;
		b[i] = num2;
	}
	build(0, 0, sz);

	unordered_map<ll, vector<ll> >mp;
	vl pref(n + 1);
	pref[0] = 0;
	mp[0].push_back(0);
	for (ll i = 0; i < n; i++) {
		pref[i + 1] = (pref[i] + a[i]) % k;
		mp[pref[i + 1]].push_back(i + 1);
	}

	ll summ1 = 0;
	for (ll i = 0; i < n; i++) {
		summ1 += a[i] * (i + 1) * (n - i);
		summ1 = (summ1 + MOD) % MOD;
	}


	for (auto &elem : mp) {
		rec(elem.second.begin(), elem.second.begin(), elem.second.end());
	}

	cout << summ1 << ' ' << summ2 << endl;

	cout << (summ1 - summ2 + MOD) % MOD;

}



int main() {
	ios::sync_with_stdio(false);
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	ll t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}
