#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
using namespace std;

typedef long double ld;
typedef long long ll;

const int MD = 1e9 + 7;

bool sol(vector < int > id, vector < string >& v, vector < string >& r, vector < bool >& used) {
	if (id.size() == 1)
		return true;

	vector < int > cnt(26, 0);
	for (int i : id) {
		for (char c : r[i])
			cnt[c - 'a']++;
	}

	char c = '?';
	for (int i = 0; i < 26; i++) {
		if (id.size() == cnt[i] && !used[i])
			c = i + 'a';
	}

	if (c == '?')
		return false;

	vector < pair < int, int > > hs;
	for (int i : id) {
		ll h = 0;
		for (char cur : v[i]) {
			if (cur == c)
				h = (2 * h + 1) % MD;
			else
				h = (2 * h) % MD;
		}
		hs.push_back({ h, i });
	}
	sort(hs.begin(), hs.end());

	int h = -1;
	bool res = true;
	used[c - 'a'] = true;
	vector < int > new_id;
	for (pair < int, int > cur : hs) {
		if (new_id.empty() || h == cur.first)
			new_id.push_back(cur.second);
		else {
			res = res && sol(new_id, v, r, used);
			new_id.clear();
			new_id.push_back(cur.second);
		}
		h = cur.first;
	}
	res = res && sol(new_id, v, r, used);

	used[c - 'a'] = false;
	return res;
}

int main() {
	ios_base::sync_with_stdio(0); cout.precision(20);
	
	int l, n;
	cin >> l >> n;

	vector < string > v(n), r(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i];

		r[i] = v[i];
		sort(r[i].begin(), r[i].end());
		string cur;
		for (int j = 0; j < r[i].size(); j++) {
			if (j == 0 || r[i][j] != r[i][j - 1])
				cur += r[i][j];
		}
		r[i] = cur;
	}

	vector < bool > used(26, false);
	vector < int > id(n);
	for (int i = 0; i < n; i++)
		id[i] = i;
	bool res = sol(id, v, r, used);

	if (res)
		cout << "YES\n";
	else
		cout << "NO\n";
}
/*
5 2
hello
world

4 4
idea
play
game
warm

4 2
game
name
*/