#include <bits/stdc++.h>
#define ll long long
using namespace std;
const int MOD = 1e9 + 123;
const int N = 1e6+10;
struct node {
	int size, hash;
	node(int _size = 0, int _hash = 0) {
		size = _size;
		hash = _hash;
	}
	
} tree[5*N];
ll sum[N], xar[N], lazy[4*N];
int n, q;
string s[N];
string t;

int len, pref_hash;
void push(int l, int r, int pos) {
	if (lazy[pos] == 0) {
		return;
	}
	if (l < r) {
		lazy[pos << 1] = lazy[pos << 1 | 1] = lazy[pos];
		
	}
	tree[pos].hash = 1LL * sum[tree[pos].size] * lazy[pos] % MOD; 
	lazy[pos] = 0;
}

void pull(int pos) {
	tree[pos].hash = (1LL * tree[pos << 1].hash * xar[tree[pos << 1 | 1].size] + tree[pos << 1 | 1].hash) % MOD;
}

void update(int l, int r, int L, int R, int v, int pos) {
	push(l, r, pos);
	if (l > R || L > r) return;
	if (L <= l && R >= r) {
		lazy[pos] = v;
		push(l, r, pos);
	} else {
		int m = l + r >> 1;
		update(l, m, L, R, v, pos << 1);
		update(m+1, r, L, R, v, pos << 1 | 1);
		pull(pos);
	}
}

void update(int l, int r, int v) {
	update(1, t.size(), l, r, v, 1);
}
map<int, int> mini, maxi;
void query(int l, int r, int pos, ll hash) {
	push(l, r, pos);
	if (l == r) {
		ll h = (hash * 37 + tree[pos].hash) % MOD;
		if (mini.count(h)) {
			len = r;
			pref_hash = h;
		} 
		return;
	}
	int m = l + r >> 1;
	push(l, m, pos << 1);
	push(m + 1, r, pos << 1 | 1);
	ll h = (hash * xar[tree[pos << 1].size] + tree[pos << 1].hash) % MOD;
	if (mini.count(h)) {
		len = m;   
		pref_hash = h;
		query(m + 1, r, pos << 1 | 1, h);
	} else {
		query(l, m, pos << 1, hash); 
	}
}

int get(int l, int r, int x, int pos) {
	push(l, r, pos);
	if (l > x || r < x) {
		return 0;
	}
	if (l == r) {
		return tree[pos].hash;
	}
	int m = l + r >> 1;
	return get(l, m, x, pos << 1) + get(m+1, r, x, pos << 1 | 1);
}

int get(int x) {
	return get(1, t.size(), x, 1);
}

void query(int l, int r) {
	query(l, r, 1, 0LL);
}

void build(int l, int r, int pos) {
	tree[pos].size = r - l + 1;
	if (l == r) {
		tree[pos].hash = t[r - 1] - 'a' + 1;
	} else {
		int m = l + r >> 1;
		build(l, m, pos << 1);
		build(m + 1, r, pos << 1 | 1);
		pull(pos);
	}
}

int get_ans() {
	len = 0, pref_hash = 0;
	query(1, t.size());
	int l = mini[pref_hash];
	int r = maxi[pref_hash];
	int ans = l - 1;
	if (len == t.size()) {
		return ans;
	}
	char ch = get(len + 1) + 'a' - 1;
	while (r >= l) {
		int m = l + r >> 1;
		if ((int)s[m].size() < len || s[m][len] < ch) {
			ans = m;
			l = m + 1;
		} else {
			r = m - 1;
		}
	}
	return ans;
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0);
	cin >> n >> q >> t;
	xar[0] = 1;
	for (int i = 1; i <= n; ++i) {
		cin >> s[i];
	}
	for (int i = 1; i < N; ++i) {
		xar[i] = 1LL * xar[i - 1] * 37 % MOD;
		sum[i] = (sum[i - 1] + xar[i - 1]) % MOD;
	}
	sort(s+1, s+n+1);
	for (int i = 1; i <= n; ++i) {
		ll h = 0;
		for (int j = 0; j < s[i].size(); ++j) {
			h = (1LL * h * 37 + s[i][j] - 'a' + 1) % MOD;
			if (mini.count(h) == 0) {
				mini[h] = i;
			}
			maxi[h] = i;
		}
	}
	build(1, t.size(), 1);
	cout << get_ans() << '\n';
	while (q--) {
		int id;
		char c;
		cin >> id >> c;
		update(id, t.size(), c - 'a' + 1);
		cout << get_ans() << '\n';
	}
}
/*
4 3
anatoly
boris
anatooo
anbbbbu
anba
5 o
3 b
7 x

4 2
anatooo
boris
anatooo
anbbbbu
anba
3 b
7 x


5 5 
abcde
buz
ababa
build
a
aba
1 b
3 z
2 u
4 z
1 a

*/



