#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <math.h>
#include <queue>
#include <map>
#include <set>
#include <stack>

using namespace std;
vector<int> u;
vector<int> d;
vector<int> r;
struct segment_tree {
	vector<long long> t;
	long long undef = -(1e18 + 7);
	int n;

	void build(int v, int vl, int vr, vector<int>& a) {
		if (vl == vr) {
			t[v] = (a[vl] == 1);
			return;
		}
		int vm = (vl + vr) / 2;
		build(2 * v + 1, vl, vm, a);
		build(2 * v + 2, vm + 1, vr, a);
		t[v] = t[2 * v + 1] + t[2 * v + 2];
	}
	segment_tree(int n_, vector<int>& a) {
		n = n_;
		t.resize(4 * n, 0);
		build(0, 0, n - 1, a);
	}
	long long query(int v, int vl, int vr, int l, int r) {
		if (r < vl || vr < l)
			return 0;
		if (l <= vl && vr <= r)
			return t[v];
		int vm = (vl + vr) / 2;
		long long ql = query(2 * v + 1, vl, vm, l, r);
		long long qr = query(2 * v + 2, vm + 1, vr, l, r);
		return ql + qr;
	}
	void modify(int v, int vl, int vr, int index, int val) {
		if (vr < index || index < vl)
			return;
		if (vl == vr && vl == index) {
			t[v] = (val == 1);
			return;
		}
		int vm = (vl + vr) / 2;
		modify(2 * v + 1, vl, vm, index, val);
		modify(2 * v + 2, vm + 1, vr, index, val);
		t[v] = t[2 * v + 1] + t[2 * v + 2];
	}
	int search(int v, int vl, int vr, int k) {
		if (vl == vr)
			return vl;
		int left = t[2 * v + 1];
		int right = t[2 * v + 2];
		int vm = (vl + vr) / 2;
		if (k <= left)
			return search(2 * v + 1, vl, vm, k);
		return search(2 * v + 2, vm + 1, vr, k - left);
	}
	int search_on_range(int l, int r, int k) {
		if (l > 0)
			return search(0, 0, n - 1, k + query(0, 0, n - 1, 0, l - 1));
		return search(0, 0, n - 1, k);
	}
};
vector<int> a;
long long s1 = 0;
long long s2 = 0;
int main() {
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		int a;
		cin >> a;
		u.push_back(a);
		s1 += a;
	}
	for (int i = 0; i < n; i++) {
		int a;
		cin >> a;
		if (a - u[i] >= 0) {
			d.push_back(a - u[i]);
			u[i] = 0;
		}
		else {
			d.push_back(0);
			u[i] = u[i] - a;
		}
		s2 += a;
	}
	if (s1 > s2) {
		cout << -1;
		return 0;
	}
	for (int i = 0; i < n; i++) {
		if (d[i] > 0)
			a.push_back(1);
		else
			a.push_back(0);
	}
	segment_tree sgt(n, a);
	for (int i = 0; i < n; i++) {
		if (u[i] == 0)
			continue;
		int v1 = sgt.search_on_range(i+1, n-1, 1);
		int t = sgt.query(0, 0, n - 1, 0, i);
		int v2 =  sgt.search_on_range(0, i, t);
		if (d[v2] != 0 && d[v1] != 0 && abs(i - v1) < abs(i - v2)) {
			r.push_back(abs(i - v1));
			if(d[v1] - u[i] > 0)
				d[v1] = d[v1] - u[i];
			if (d[v1] - u[i] <= 0) {
				u[i] = u[i] - d[v1];
				d[v1] = 0;
				sgt.modify(0, 0, n - 1, v1, 0);
				i--;
			}
			continue;
		}
		if (d[v1] != 0 && d[v2] != 0 && abs(i - v1) >= abs(i - v2)) {
			r.push_back(abs(i - v2));
			if (d[v2] - u[i] > 0)
				d[v2] = d[v2] - u[i];
			if (d[v2] - u[i] <= 0) {
				u[i] = u[i] - d[v2];
				d[v2] = 0;
				sgt.modify(0, 0, n - 1, v2, 0);
				i--;
			}
			continue;
		}
		if (d[v1] != 0) {
			r.push_back(abs(i - v2));
			if (d[v2] - u[i] > 0)
				d[v2] = d[v2] - u[i];
			if (d[v2] - u[i] <= 0) {
				u[i] = u[i] - d[v2];
				d[v2] = 0;
				sgt.modify(0, 0, n - 1, v2, 0);
				i--;
			}
			continue;
		}
		if (d[v2] != 0) {
			r.push_back(abs(i - v2));
			if (d[v2] - u[i] > 0)
				d[v2] = d[v2] - u[i];
			if (d[v2] - u[i] <= 0) {
				u[i] = u[i] - d[v2];
				d[v2] = 0;
				sgt.modify(0, 0, n - 1, v2, 0);
				i--;
			}
			continue;
		}
	}
	if (r.size() == 0)
		cout << 0;
	else
		cout << *max_element(r.begin(), r.end());

}