#include <bits/stdc++.h>

using namespace std;
using ld = long double;
using ii = __int128;

struct FFF {
    ii a, b;

    FFF(ii a = 0, ii b = 1) : a(a), b(b) { }

    bool operator < (const FFF& f) const {
        if (a / b != f.a / f.b) return a / b <  f.a / f.b;
        ii p = a % b;
        ii q = f.a % f.b;
        return p * f.b < q * b;
    }

    FFF operator * (const FFF& f) {
        return FFF(a * f.a, b * f.b);
    }

    FFF operator + (const FFF& f) {
        return FFF(a * f.b + b * f.a, b * f.b);
    }

    FFF operator - (const FFF& f) {
        return FFF(a * f.b - b * f.a, b * f.b);
    }
};

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int n; cin >> n;
    vector<int> a(n);
    for (int& x : a) cin >> x;

    vector<int> mnp(n), mxp(n), mns(n), mxs(n);

    mnp[0] = mxp[0] = a[0];
    mns[n-1] = mxs[n-1] = a[n-1];
    for (int i = 1; i < n; ++i) {
        mxp[i] = max(mxp[i-1], a[i]);
        mnp[i] = min(mnp[i-1], a[i]);
    }

    for (int i = n-1; i--; ) {
        mxs[i] = max(mxs[i+1], a[i]);
        mns[i] = min(mns[i+1], a[i]);
    }


    cout << fixed << setprecision(12) << 1.0;
    for (int k = 1; k < n; ++k) {
        ii a = mxp[k-1], b = mxs[k];
        ii c = mnp[k-1], d = mns[k];

        // cout << endl;
        // cout << (int)a << " " << (int)b << " " << (int)c << " " << (int)d  << endl;

        vector<FFF> t0 = { {0, 1}, {1, 1} };

        if (a < b) t0.push_back({a, b});
        if (c < d) t0.push_back({c, d});
        sort(t0.begin(), t0.end());

        FFF t, dst;
        bool fst = true;

        for (const auto& f : t0) {
            FFF mx = max(FFF(a), FFF(b) * f);
            FFF mn = min(FFF(c), FFF(d) * f);

            FFF ndst = mx - mn;
            // cout << (int)f.a << "/" << (int)f.b << " ==> " << (int)ndst.a << " / " << (int)ndst.b << endl;
            // cout << (int)mx.a << "/" << (int)mx.b << " , " << (int)mn.a << "/" << (int)mn.b << endl;

            if (fst || mx - mn < dst) {
                dst = mx - mn;
                t = f;
            }

            fst = false;
        }

        cout << ' ' << 1 - (ld)t.a/t.b;
    }

    cout << endl;
}
