#include <iostream>

using namespace std;
using ll = long long;

const int N = 501;
const int MOD = 998244353;

ll dp[N][N][N], kek[N][N];

ll fact[N];

int powb(int a, int n) {
    int res = 1;
    for (; n != 0; n >>= 1, a = (ll)a*a%MOD) {
        if (n&1) res = (ll)res*a%MOD;
    }
    return res;
}

int rev(int a, int m = MOD) {
    return a == 1 ? 1 : m - (ll)m*rev(m%a, a)/a;
}

int calc_square(int n, int m) {
    n--;
    for (int l = 1; l <= m; ++l)
    for (int r = 1; r <= m; ++r) {
        dp[0][l][r] = 1;
    }

    for (int i = 1; i <= n; ++i) {
        for (int l = 1; l <= m; ++l)
        for (int r = l; r <= m; ++r) {
            dp[i][l][r] = dp[i-1][l][r] + dp[i][l-1][r] + dp[i][min(l, r-1)][r-1] - dp[i][l-1][r-1];
            dp[i][l][r] %= MOD;
            if (dp[i][l][r] < 0) dp[i][l][r] += MOD;
        }
    }

    return dp[n][m][m];
}

int propose(int n, int m) {
    ll ans = 1;

    if (n == 1) return 1;

    for (int k = 0; k < n; ++k) {
        ans = (ll)ans * powb(m+k, k==0 || k==n-1 ? 1 : 2) % MOD;
    }

    return ans;
}

int answer(int n, int m) {
    return (ll) propose(n, m) * rev(propose(n, 1)) % MOD;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int n, m; cin >> n >> m;
    cout << answer(n, m) << endl;

    return 0;
}
