﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#define int long long
using namespace std;

void write(vector<int> v) {
    for (auto elem : v)
        cout << elem << ' ';
    cout << endl;
}

const double eps = 1e-9;

signed main()
{
    cout << fixed << setprecision(10);
    int n;
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    int min1, max1, min2, max2;
    vector<int> maximusLeft(n), minimusLeft(n), maximusRight(n), minimusRight(n);
    maximusLeft[0] = v[0];
    minimusLeft[0] = v[0];
    for (int i = 1; i < n; i++) {
        maximusLeft[i] = max(v[i], maximusLeft[i - 1]);
        minimusLeft[i] = min(v[i], minimusLeft[i - 1]);
    }
    maximusRight[n - 1] = v[n - 1];
    minimusRight[n - 1] = v[n - 1];
    for (int i = n - 2; i > -1; i--) {
        maximusRight[i] = max(v[i], maximusRight[i + 1]);
        minimusRight[i] = min(v[i], minimusRight[i + 1]);
    }
    
    /*cout << endl;
    write(minimusLeft);
    write(minimusRight);
    write(maximusLeft);
    write(maximusRight);
    cout << endl;*/
    cout << 1 << ' ';
    for (int k = 1; k < n; k++) {
        min1 = minimusLeft[k - 1];
        min2 = minimusRight[k];
        max1 = maximusLeft[k - 1];
        max2 = maximusRight[k];

        if (max1 >= max2) {
            if (min2 < min1)
                cout << 0 << ' ';
            else
                cout << (min2 - min1) / (double) min2 << ' ';
            continue;
        }
        cout << max((1 - min1 / (double)min2), (1 - max1 / (double)max2)) << ' ';
    }
}


// max(max1, max2) - min(min1, min2)
// min1 = min2(1 - t)
// min1 = min2 - t min2
// t = (min2 - min1) / min2