#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

const long long maxN = 1e5;

struct item {
	long long a, b, c;
	friend std::istream& operator>>(std::istream& is, item& i) {
		is >> i.a >> i.b >> i.c;
		return is;
	}
	long double getverx() {
		return -(long double)b / 2 / a;
	}
	long double getvery() {
		long double x = getverx();
		return a * x * x + b * x + c;
	}
	long double gety(long double x) {
		return a * x * x + b * x + c;
	}
	bool operator!=(item& other) {
		return a != other.a || b != other.b || c != other.c;
	}
} a[maxN], best;

struct Event {
	long long b;
	long double x;
	Event(long double x = 0, long long b = 1) : x(x), b(b) {}
	bool operator<(Event& other) {
		return x < other.x || (x == other.x && b > other.b);
	}
};

long long n, cur;
std::vector<Event> tl;

int main() {
	std::cin >> n;
	for (long long i = 0; i < n; i++)
		std::cin >> a[i];
	best = a[0];
	for (long long i = 0; i < n; i++) {
		if (best.a < 0 && a[i].a > 0)
			best = a[i];
		else if (best.a > 0 && a[i].a > 0 && best.getvery() < a[i].getvery())
			best = a[i];
		else if (best.a < 0 && a[i].a < 0 && best.getvery() > a[i].getvery())
			best = a[i];
	}
	for (long long i = 0; i < n; i++)
		if (best != a[i]) {
			if (a[i].a == best.a) {
				long double x = (long double)(a[i].c - best.c) / (best.b - a[i].b);
				if (best.a > 0) {
					if (best.gety(x + 1) > a[i].gety(x + 1))
						tl.push_back(Event(x, 1));
					else {
						cur++;
						tl.push_back(Event(x, -1));
					}
				}
				else {
					if (best.gety(x + 1) < a[i].gety(x + 1))
						tl.push_back(Event(x, 1));
					else {
						cur++;
						tl.push_back(Event(x, -1));
					}
				}
			}
			else {
				long double d = (best.b - a[i].b) * (best.b - a[i].b) - 4 * (best.a - a[i].a) * (best.c - a[i].c);
				if (d < 0)
					continue;
				if (d == 0) {
					long double x = (long double)(-(best.b - a[i].b)) / 2 / (best.a - a[i].a);
					if (best.a > 0) {
						if (best.gety(x + 1) > a[i].gety(x + 1))
							tl.push_back(Event(x, 1));
						else {
							cur++;
							tl.push_back(Event(x, -1));
						}
					}
					else {
						if (best.gety(x + 1) < a[i].gety(x + 1))
							tl.push_back(Event(x, 1));
						else {
							cur++;
							tl.push_back(Event(x, -1));
						}
					}
				}
				else {
					d = sqrt(d);
					long double x1 = (long double)(-(best.b - a[i].b) - d) / 2 / (best.a - a[i].a);
					long double x2 = (long double)(-(best.b - a[i].b) + d) / 2 / (best.a - a[i].a);
					if (x1 > x2)
						std::swap(x1, x2);
					tl.push_back(Event(x1, 1));
					tl.push_back(Event(x2, -1));
				}
			}
		}
		else
			cur++;
	std::sort(tl.begin(), tl.end());
	for (long long i = 0; i < tl.size(); i++) {
		cur += tl[i].b;
		if (cur == n) {
			printf("%.17Lf %.17Lf", tl[i].x, best.gety(tl[i].x));
			break;
		}
	}
	return 0;
}