#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

const long long maxN = 1e5, INF = 2e18;

struct item {
    long long a, b, c;
    friend std::istream& operator>>(std::istream& is, item& i) {
        is >> i.a >> i.b >> i.c;
        return is;
    }
    long double getverx() {
        return -(long double)b / 2 / a;
    }
    long double getvery() {
        long double x = getverx();
        return a * x * x + b * x + c;
    }
    long double gety(long double x) {
        return a * x * x + b * x + c;
    }
    bool operator!=(item& other) {
        return a != other.a || b != other.b || c != other.c;
    }
} a[maxN], best;

long long n;
long double lx = -INF, rx = INF;

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);
    std::cin >> n;
    for (long long i = 0; i < n; i++)
        std::cin >> a[i];
    if (n == 1) {
        printf("%.17Lf %.17Lf", (long double)0, a[0].gety(0));
        return 0;
    }
    best = a[0];
    for (long long i = 1; i < n; i++) {
        if (best.a < 0 && a[i].a > 0)
            best = a[i];
        else if (best.a > 0 && a[i].a > 0 && best.getvery() < a[i].getvery())
            best = a[i];
        else if (best.a < 0 && a[i].a < 0 && best.getvery() > a[i].getvery())
            best = a[i];
        else if (best.a > 0 && a[i].a > 0 && best.getvery() == a[i].getvery() && best.a > a[i].a)
            best = a[i];
        else if (best.a < 0 && a[i].a < 0 && best.getvery() == a[i].getvery() && best.a < a[i].a)
            best = a[i];
    }
    for (long long i = 0; i < n; i++)
        if (best != a[i]) {
            if (a[i].a == best.a) {
                if (best.b == a[i].b)
                    continue;
                long double x = (long double)(a[i].c - best.c) / (best.b - a[i].b);
                if (best.a > 0) {
                    if (best.gety(x + 1) > a[i].gety(x + 1))
                        lx = std::max(lx, x);
                    else
                        rx = std::min(rx, x);
                }
                else {
                    if (best.gety(x + 1) < a[i].gety(x + 1))
                        lx = std::max(lx, x);
                    else
                        rx = std::min(rx, x);
                }
            }
            else {
                long double d = (best.b - a[i].b) * (best.b - a[i].b) - 4 * (best.a - a[i].a) * (best.c - a[i].c);
                if (d < 0)
                    continue;
                if (d == 0) {
                    long double x = (long double)(a[i].b - best.b) / 2 / (best.a - a[i].a);
                    if (best.a > 0) {
                        if (best.gety(x + 1) > a[i].gety(x + 1))
                            lx = std::max(lx, x);
                        else
                            rx = std::min(rx, x);
                    }
                    else {
                        if (best.gety(x + 1) < a[i].gety(x + 1))
                            lx = std::max(lx, x);
                        else
                            rx = std::min(rx, x);
                    }
                }
                else {
                    d = sqrt(d);
                    long double x1 = (long double)(-(best.b - a[i].b) - d) / 2 / (best.a - a[i].a);
                    long double x2 = (long double)(-(best.b - a[i].b) + d) / 2 / (best.a - a[i].a);
                    if (x1 > x2)
                        std::swap(x1, x2);
                    lx = std::max(lx, x1);
                    rx = std::min(rx, x2);
                }
            }
        }
    printf("%.18Lf %.18Lf", lx, best.gety(lx));
    return 0;
}